/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)cdr_md5.h    generated by: makeheader    Sat Mar  9 09:37:57 2024
 *
 *		built from:	md5.ifc
 */

#ifndef cdr_md5_h
#define cdr_md5_h


 #ifndef cdr_dll_h
    #include "cdr/cdr_dll.h"
 #endif
 #ifndef osapi_type_h
    #include "osapi/osapi_type.h"
 #endif
 #ifndef cdr_type_h
    #include "cdr/cdr_type.h"
 #endif 

#ifdef __cplusplus
    extern "C" {
#endif


#define CDR_MD5_DIGEST_SIZE (16)


typedef RTICdrOctet md5_byte_t; /* 8-bit byte */


typedef RTICdrUnsignedLong md5_word_t; /* 32-bit word */


typedef struct md5_state_s {
    md5_word_t count[2];	/* message length in bits, lsw first */
    md5_word_t abcd[4];		/* digest buffer */
    md5_byte_t buf[64];		/* accumulate block */
} md5_state_t;

extern RTICdrDllExport
void RTICdrMD5_init(md5_state_t *pms);

extern RTICdrDllExport
void RTICdrMD5_append(md5_state_t *pms, const md5_byte_t *data, int nbytes);

extern RTICdrDllExport
void RTICdrMD5_finish(md5_state_t *pms, md5_byte_t digest[CDR_MD5_DIGEST_SIZE]);


#ifdef __cplusplus
    }   /* extern "C" */
#endif

#endif /* cdr_md5_h */
