/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)cdr_type_impl.h    generated by: makeheader    Sat Mar  9 09:37:57 2024
 *
 *		built from:	type_impl.ifc
 */

#ifndef cdr_type_impl_h
#define cdr_type_impl_h


#ifdef __cplusplus
    extern "C" {
#endif



#define RTICdrType_getPrimitiveTypeAlignment(type)    \
  ((((type) == RTI_CDR_CHAR_TYPE) ||                  \
    ((type) == RTI_CDR_OCTET_TYPE) ||                 \
    ((type) == RTI_CDR_BOOLEAN_TYPE)) ? 1 :           \
   ((((type) == RTI_CDR_SHORT_TYPE) ||                \
     ((type) == RTI_CDR_UNSIGNED_SHORT_TYPE)) ? 2 :   \
    ((((type) == RTI_CDR_WCHAR_TYPE) ||               \
      ((type) == RTI_CDR_LONG_TYPE) ||                \
      ((type) == RTI_CDR_UNSIGNED_LONG_TYPE) ||       \
      ((type) == RTI_CDR_FLOAT_TYPE) ||               \
      ((type) == RTI_CDR_ENUM_TYPE)) ? 4 :            \
     ((((type) == RTI_CDR_LONG_LONG_TYPE) ||          \
       ((type) == RTI_CDR_UNSIGNED_LONG_LONG_TYPE) || \
       ((type) == RTI_CDR_DOUBLE_TYPE) ||             \
       ((type) == RTI_CDR_LONG_DOUBLE_TYPE)) ? 8 : 0))))

#define RTICdrType_getPrimitiveTypeSize(type)         \
  ((((type) == RTI_CDR_CHAR_TYPE) ||                  \
    ((type) == RTI_CDR_OCTET_TYPE) ||                 \
    ((type) == RTI_CDR_BOOLEAN_TYPE)) ? 1U :          \
   ((((type) == RTI_CDR_SHORT_TYPE) ||                \
     ((type) == RTI_CDR_UNSIGNED_SHORT_TYPE)) ? 2U :  \
    ((((type) == RTI_CDR_WCHAR_TYPE)||                \
      ((type) == RTI_CDR_LONG_TYPE) ||                \
      ((type) == RTI_CDR_UNSIGNED_LONG_TYPE) ||       \
      ((type) == RTI_CDR_FLOAT_TYPE) ||               \
      ((type) == RTI_CDR_ENUM_TYPE)) ? 4U :           \
     ((((type) == RTI_CDR_LONG_LONG_TYPE) ||          \
       ((type) == RTI_CDR_UNSIGNED_LONG_LONG_TYPE) || \
       ((type) == RTI_CDR_DOUBLE_TYPE)) ? 8U :        \
      ((type) == RTI_CDR_LONG_DOUBLE_TYPE) ? 16U : 0U))))
      



#define RTICdrType_getPadSize(currentSize, align) \
  (((align) <= (RTI_UINT32) RTI_CDR_MAX_ALIGNMENT) ? \
    (RTIOsapiAlignment_alignUInt32Up((currentSize), (align)) - (currentSize)) : \
    (RTIOsapiAlignment_alignUInt32Up((currentSize), (RTI_UINT32) RTI_CDR_MAX_ALIGNMENT) \
     - (currentSize)))

#define RTICdrType_get1ByteMaxSizeSerialized(currentSize) (1)

#define RTICdrType_get2ByteMaxSizeSerialized(currentSize) \
  (RTICdrType_getPadSize((currentSize), RTI_CDR_SHORT_ALIGN) + \
   RTI_CDR_SHORT_SIZE)

#define RTICdrType_get4ByteMaxSizeSerialized(currentSize) \
  (RTICdrType_getPadSize((currentSize), (RTI_UINT32) RTI_CDR_LONG_ALIGN) + \
   (RTI_UINT32) RTI_CDR_LONG_SIZE)

#define RTICdrType_get8ByteMaxSizeSerialized(currentSize) \
  (RTICdrType_getPadSize((currentSize), RTI_CDR_LONG_LONG_ALIGN) + \
   RTI_CDR_LONG_LONG_SIZE)

#define RTICdrType_get16ByteMaxSizeSerialized(currentSize) \
  (RTICdrType_getPadSize((currentSize), RTI_CDR_LONG_DOUBLE_ALIGN) + \
   RTI_CDR_LONG_DOUBLE_SIZE)




#define RTICdrType_getCharMaxSizeSerialized \
  RTICdrType_get1ByteMaxSizeSerialized

#define RTICdrType_getWcharMaxSizeSerialized \
  RTICdrType_get4ByteMaxSizeSerialized

#define RTICdrType_getCORBAWCharMaxSizeSerialized \
  RTICdrType_get4ByteMaxSizeSerialized

#define RTICdrType_getOctetMaxSizeSerialized \
  RTICdrType_get1ByteMaxSizeSerialized

#define RTICdrType_getShortMaxSizeSerialized \
  RTICdrType_get2ByteMaxSizeSerialized

#define RTICdrType_getUnsignedShortMaxSizeSerialized \
  RTICdrType_get2ByteMaxSizeSerialized

#define RTICdrType_getLongMaxSizeSerialized \
  RTICdrType_get4ByteMaxSizeSerialized

#define RTICdrType_getUnsignedLongMaxSizeSerialized \
  RTICdrType_get4ByteMaxSizeSerialized

#define RTICdrType_getLongLongMaxSizeSerialized \
  RTICdrType_get8ByteMaxSizeSerialized

#define RTICdrType_getUnsignedLongLongMaxSizeSerialized \
  RTICdrType_get8ByteMaxSizeSerialized

#define RTICdrType_getFloatMaxSizeSerialized \
  RTICdrType_get4ByteMaxSizeSerialized

#define RTICdrType_getDoubleMaxSizeSerialized \
  RTICdrType_get8ByteMaxSizeSerialized

#define RTICdrType_getLongDoubleMaxSizeSerialized \
  RTICdrType_get16ByteMaxSizeSerialized

#define RTICdrType_getBooleanMaxSizeSerialized \
  RTICdrType_get1ByteMaxSizeSerialized

#define RTICdrType_getEnumMaxSizeSerialized \
  RTICdrType_get4ByteMaxSizeSerialized

#define RTICdrType_getStringMaxSizeSerialized(currentSize, length) \
  (RTICdrType_get4ByteMaxSizeSerialized((currentSize)) + \
   (RTI_CDR_CHAR_SIZE * (length)))

#define RTICdrType_getStringSerializedSize(currentSize, in) \
  (RTICdrType_get4ByteMaxSizeSerialized((currentSize)) + \
      (((const char *) (in) == NULL)?0:((unsigned int)(strlen((in)) + 1))))

#define RTICdrType_getWstringMaxSizeSerialized(currentSize, length) \
  (RTICdrType_get4ByteMaxSizeSerialized((currentSize)) + \
   (RTI_CDR_WCHAR_SIZE * (length)))

#define RTICdrType_getWstringSerializedSize(currentSize, in) \
  (RTICdrType_get4ByteMaxSizeSerialized((currentSize)) + \
      ((((void *) (in) == NULL)?0:(RTICdrType_getWstringLength((in))*RTI_CDR_WCHAR_SIZE)) + RTI_CDR_WCHAR_SIZE))

#define RTICdrType_getCORBAWstringSerializedSize(currentSize, in, charType) \
  (RTICdrType_get4ByteMaxSizeSerialized((currentSize)) + \
      ((((in) == NULL)?0:(RTICdrType_getCORBAWstringLength((in), (charType))*RTI_CDR_WCHAR_SIZE)) + RTI_CDR_WCHAR_SIZE))

#define RTICdrType_getPrimitiveArrayMaxSizeSerialized(currentSize, length, type) \
  ((length != 0)? \
  ((RTICdrType_getPadSize((currentSize), \
   RTICdrType_getPrimitiveTypeSize((type))) + \
   (RTICdrType_getPrimitiveTypeSize((type)) * (length)))) : \
   0)

#define RTICdrType_getCORBAWCharArrayMaxSizeSerialized(currentSize, length, type) \
  ((length != 0)? \
  ((RTICdrType_getPadSize((currentSize), \
   RTICdrType_getPrimitiveTypeSize((RTI_CDR_UNSIGNED_LONG_TYPE))) + \
   (RTICdrType_getPrimitiveTypeSize((RTI_CDR_UNSIGNED_LONG_TYPE)) * (length)))): \
   0)

#define RTICdrType_getPrimitiveSequenceMaxSizeSerialized(currentSize, maximumLength, type) \
  (RTICdrType_get4ByteMaxSizeSerialized((currentSize)) + \
   RTICdrType_getPrimitiveArrayMaxSizeSerialized( \
     (currentSize) + RTICdrType_get4ByteMaxSizeSerialized( \
       (currentSize)), (maximumLength), (type)))

#define RTICdrType_getPrimitiveSequenceSerializedSize(currentSize, length, type) \
  (RTICdrType_get4ByteMaxSizeSerialized((currentSize)) + \
   RTICdrType_getPrimitiveArrayMaxSizeSerialized( \
     (currentSize) + RTICdrType_get4ByteMaxSizeSerialized( \
       (currentSize)), (length), (type)))

#define RTICdrType_getCORBAWCharSequenceMaxSizeSerialized(currentSize, maximumLength, type) \
  (RTICdrType_get4ByteMaxSizeSerialized((currentSize)) + \
   RTICdrType_getPrimitiveArrayMaxSizeSerialized( \
     (currentSize) + RTICdrType_get4ByteMaxSizeSerialized( \
       (currentSize)), (maximumLength), (RTI_CDR_UNSIGNED_LONG_TYPE)))



#define RTICdrType_printNativeLongLongMacro(value, desc, indent)      \
   RTICdrType_printIndent((indent));                                  \
   (((void *) (value) == NULL) ?                                               \
    (((void *) (desc) != NULL) ? RTILogParamString_printPlain("%s: NULL\n", (desc)) :         \
      RTILogParamString_printPlain("NULL\n")) :                                      \
    (((void *) (desc) != NULL) ?                                               \
      RTILogParamString_printPlain("%s: %lld\n", (desc), *(value)) :                 \
      RTILogParamString_printPlain("%lld\n", *(value))))

#define RTICdrType_printNativeUnsignedLongLongMacro(value, desc, indent) \
   RTICdrType_printIndent((indent));                                  \
   (((void *) (value) == NULL) ?                                               \
    (((void *) (desc) != NULL) ? RTILogParamString_printPlain("%s: NULL\n", (desc)) :         \
      RTILogParamString_printPlain("NULL\n")) :                                      \
    (((void *) (desc) != NULL) ?                                               \
      RTILogParamString_printPlain("%s: %llu\n", (desc), *(value)) :                 \
      RTILogParamString_printPlain("%llu\n", *(value))))

#define RTICdrType_printNativeLongDoubleMacro(value, desc, indent)     \
   RTICdrType_printIndent((indent));                                   \
   (((void *) (value) == NULL) ?                                                \
    (((void *) (desc) != NULL) ? RTILogParamString_printPlain("%s: NULL\n", (desc)) :          \
      RTILogParamString_printPlain("NULL\n")) :                                       \
    (((void *) (desc) != NULL) ? RTILogParamString_printPlain("%s: %Lf\n", (desc), *(value)) : \
      RTILogParamString_printPlain("%Lf\n", *(value))))

#define RTICdrType_printNotImplMacro(value, desc, indent)             \
   RTICdrType_printIndent((indent));                                  \
   (((void *) (value) == NULL) ?                                               \
    (((void *) (desc) != NULL) ? RTILogParamString_printPlain("%s: NULL\n", (desc)) :          \
      RTILogParamString_printPlain("NULL\n")) :                                       \
    (((void *) (desc) != NULL) ?                                               \
      RTILogParamString_printPlain("%s: not implemented\n", (desc)) :                 \
      RTILogParamString_printPlain("not implemented\n")))

#define RTICdrType_printNativeLongLong(value, desc, indent) \
 RTICdrType_printNativeLongLongMacro(value, desc, indent)
#define RTICdrType_printNativeUnsignedLongLong(value, desc, indent) \
 RTICdrType_printNativeUnsignedLongLongMacro(value, desc, indent)

#if (RTI_CDR_SIZEOF_LONG_DOUBLE == 16)
#define RTICdrType_printNativeLongDouble(value, desc, indent) \
 RTICdrType_printNativeLongDoubleMacro(value, desc, indent)
#else
#define RTICdrType_printNativeLongDouble(value, desc, indent) \
 RTICdrType_printNotImplMacro(value, desc, indent)
#endif




#define RTICdrType_init8Byte(value) \
  (((void *) (value) == NULL) ? RTI_FALSE : \
   (memset((value), 0, RTI_CDR_LONG_LONG_SIZE), RTI_TRUE))

#define RTICdrType_initChar(value) \
  (((void *) (value) == NULL) ? RTI_FALSE : \
   (*(value) = (RTICdrChar)0, RTI_TRUE))

#define RTICdrType_initWchar(value) \
  (((void *) (value) == NULL) ? RTI_FALSE : \
   (*(value) = (RTICdrWchar)0, RTI_TRUE))

#define RTICdrType_initCORBAWChar(value,type)\
    (\
	((void *) (value) == NULL) ? RTI_FALSE :\
	(\
	    ((type)==RTI_CDR_UNSIGNED_SHORT_TYPE)?\
	    (memset((value),0,RTI_CDR_UNSIGNED_SHORT_SIZE),RTI_TRUE):\
            (memset((value),0,RTI_CDR_UNSIGNED_LONG_SIZE),RTI_TRUE)\
	)\
    )

#define RTICdrType_initOctet(value) \
  (((void *) (value) == NULL) ? RTI_FALSE : \
   (*(value) = (RTICdrOctet)0, RTI_TRUE))

#define RTICdrType_initShort(value) \
  (((void *) (value) == NULL) ? RTI_FALSE : \
   (*(value) = (RTICdrShort)0, RTI_TRUE))

#define RTICdrType_initUnsignedShort(value) \
  (((void *) (value) == NULL) ? RTI_FALSE : \
   (*(value) = (RTICdrUnsignedShort)0, RTI_TRUE))

#define RTICdrType_initLong(value) \
  (((void *) (value) == NULL) ? RTI_FALSE : \
   (*(value) = (RTICdrLong)0, RTI_TRUE))

#define RTICdrType_initUnsignedLong(value) \
  (((void *) (value) == NULL) ? RTI_FALSE : \
   (*(value) = (RTICdrUnsignedLong)0, RTI_TRUE))

#define RTICdrType_initLongLong(value) \
   RTICdrType_init8Byte((RTICdr8Byte *)(value))

#define RTICdrType_initUnsignedLongLong(value) \
   RTICdrType_init8Byte((RTICdr8Byte *)(value))

#define RTICdrType_initFloat(value) \
  (((void *) (value) == NULL) ? RTI_FALSE : \
   (*(value) = (RTICdrFloat)0, RTI_TRUE))

#define RTICdrType_initDouble(value) \
  (((void *) (value) == NULL) ? RTI_FALSE : \
   (*(value) = (RTICdrDouble)0, RTI_TRUE))

#define RTICdrType_initLongDouble(value) \
   RTIXCdrType_init16Byte((RTICdr16Byte *)(value))

#define RTICdrType_initBoolean(value) \
  (((void *) (value) == NULL) ? RTI_FALSE : \
   (*(value) = RTI_CDR_BOOLEAN_FALSE, RTI_TRUE))

#define RTICdrType_initEnum(value) \
  (((void *) (value) == NULL) ? RTI_FALSE : \
   (*(value) = (RTICdrEnum)0, RTI_TRUE))

#define RTICdrType_initVariableSizedInteger(value,size)                                                 \
  ((void *) (value) == NULL ? RTI_FALSE :                                                                         \
     ((size) == 1 ? ((*(RTICdrOctet*)value) = 0,RTI_TRUE) :                                              \
         ((size) == 2 ? ((*(RTICdrUnsignedShort*)(value)) = 0,RTI_TRUE) :                                  \
             ((size) == 4 ? ((*(RTICdrUnsignedLong*)(value)) = 0,RTI_TRUE) : RTI_FALSE))))

/* (size == 8 ? (RTICdrType_init8Byte((RTICdr8Byte *)(value)),RTI_TRUE) : RTI_FALSE))))) */

#define RTICdrType_initArray RTIXCdrType_initArray

#define RTICdrType_initString RTIXCdrType_initString

#define RTICdrType_initWstring RTIXCdrType_initWstring

#define RTICdrType_initArrayUnsafe RTIXCdrType_initArrayUnsafe




#define RTICdrType_copy8Byte(out, in) \
  (((void *) (out) == NULL || (void *) (in) == NULL) ? RTI_FALSE : \
   (memcpy((out), (in), RTI_CDR_LONG_LONG_SIZE), RTI_TRUE))

#define RTICdrType_copy16Byte(out, in) \
  (((void *) (out) == NULL || (void *) (in) == NULL) ? RTI_FALSE : \
   (memcpy((out), (in), RTI_CDR_LONG_DOUBLE_SIZE), RTI_TRUE))

#define RTICdrType_copyChar RTIXCdrType_copyChar


#define RTICdrType_copyWchar RTIXCdrType_copyWchar

#define RTICdrType_copyWstringEx RTIXCdrType_copyWstringEx
#define RTICdrType_copyStringEx RTIXCdrType_copyStringEx
#define RTICdrType_getWstringLength RTIXCdrType_getWstringLength

#define RTICdrType_copyCORBAWChar(out, in, type)\
    (\
	((void *) (out) == NULL || (void *) (in) == NULL) ? RTI_FALSE :\
	(\
	    ((type)==RTI_CDR_UNSIGNED_SHORT_TYPE)?\
	    (memcpy((out),(in),RTI_CDR_UNSIGNED_SHORT_SIZE),RTI_TRUE):\
            (memcpy((out),(in),RTI_CDR_UNSIGNED_LONG_SIZE),RTI_TRUE)\
	)\
    )

#define RTICdrType_copyOctet RTIXCdrType_copyOctet

#define RTICdrType_copyShort RTIXCdrType_copyShort

#define RTICdrType_copyUnsignedShort RTIXCdrType_copyUnsignedShort

#define RTICdrType_copyLong RTIXCdrType_copyLong

#define RTICdrType_copyUnsignedLong RTIXCdrType_copyUnsignedLong

#define RTICdrType_copyLongLong RTIXCdrType_copyLongLong

#define RTICdrType_copyUnsignedLongLong RTIXCdrType_copyUnsignedLongLong

#define RTICdrType_copyFloat RTIXCdrType_copyFloat

#define RTICdrType_copyDouble RTIXCdrType_copyDouble

#define RTICdrType_copyLongDouble RTIXCdrType_copyLongDouble

#define RTICdrType_copyBoolean RTIXCdrType_copyBoolean

#define RTICdrType_copyEnum(out, in) \
  (((void *) (out) == NULL || (void *) (in) == NULL) ? RTI_FALSE : \
   (*(out) = *(in), RTI_TRUE))

#define RTICdrType_copyVariableSizedInteger(out,in,size)                                                \
  (((void *) (out) == NULL) || ((void *) (in) == NULL) ? RTI_FALSE :                                                          \
     (size == 1 ? (*(RTICdrOctet*)(out) = *(RTICdrOctet*)(in),RTI_TRUE) :                               \
         (size == 2 ? (*(RTICdrUnsignedShort*)(out) = *(RTICdrUnsignedShort*)(in),RTI_TRUE) :           \
             (size == 4 ? (*(RTICdrUnsignedLong*)(out) = *(RTICdrUnsignedLong*)(in),RTI_TRUE) : RTI_FALSE))))

#define RTICdrType_copyArray RTIXCdrType_copyArray

#define RTICdrType_copyString(out, in, maximumLength) \
   (((void *) (in) == NULL) ? RTI_FALSE : \
   ((strlen((in)) + 1 > (maximumLength)) ? RTI_FALSE : \
    RTICdrType_copyArray((out), (in), strlen((in)) + 1, \
                         sizeof(RTICdrChar))))

#define RTICdrType_copyWstring(out, in, maximumLength) \
   (((void *) (in) == NULL) ? RTI_FALSE : \
   ((RTICdrType_getWstringLength((in)) + 1 > (maximumLength)) ? RTI_FALSE : \
    RTICdrType_copyArray((out), (in), RTICdrType_getWstringLength((in)) + 1, \
                         sizeof(RTICdrWchar))))




#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* cdr_type_impl_h */
