/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)clock_mock.h    generated by: makeheader    Sat Mar  9 09:37:31 2024
 *
 *		built from:	mock.ifc
 */

#ifndef clock_mock_h
#define clock_mock_h


#include "clock/clock_interface.h"
#include "clock/clock_dll.h"

#ifdef __cplusplus
extern "C" {
#endif

struct RTIMockClock;

struct RTIMockClockProperty {
    /*
     * If true, the clock is created in a stopped state. If false,
     * the clock is created in a running state.
     */
    RTIBool isStopped;
    /* 
     * The kind of clock to create as the underlying clock of the mock 
     * clock
     */
    RTIClockKind internalClockKind;
};


#define RTIMockClockProperty_INITIALIZER \
{ \
    RTI_FALSE, /* isStopped */ \
    RTI_SYSTEM_CLOCK /* internalClockKind */ \
}

extern RTIClockDllExport 
RTIBool RTIMockClock_setTime(struct RTIClock *clock, struct RTINtpTime *now);

extern RTIClockDllExport
RTIBool RTIMockClock_advance(
        struct RTIClock *clock, 
        struct RTINtpTime *advanceTime);

extern RTIClockDllExport
RTIBool RTIMockClock_advanceSeconds(
        struct RTIClock *clock,
        RTI_INT64 seconds);

extern RTIClockDllExport
RTIBool RTIMockClock_start(struct RTIClock *clock);

extern RTIClockDllExport
void RTIMockClock_stop(struct RTIClock *clock);

extern RTIClockDllExport void RTIMockClock_delete(struct RTIClock *me);

extern RTIClockDllExport 
struct RTIClock *RTIMockClock_new(const struct RTIMockClockProperty *property);


#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* clock_mock_h */
