/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)dds_c_asyncwaitset_impl.h    generated by: makeheader    Sat Mar  9 09:39:06 2024
 *
 *		built from:	asyncwaitset_impl.ifc
 */

#ifndef dds_c_asyncwaitset_impl_h
#define dds_c_asyncwaitset_impl_h



#ifndef osapi_thread_h
  #include "osapi/osapi_thread.h"
#endif
    
#ifndef dds_c_infrastructure_h
  #include "dds_c/dds_c_infrastructure.h"
#endif

#ifndef dds_c_domain_h
  #include "dds_c/dds_c_domain.h"
#endif

#ifndef dds_c_asyncwaitset_h
  #include "dds_c/dds_c_asyncwaitset.h"
#endif


#ifdef __cplusplus
    extern "C" {
#endif
        

extern DDSCDllExport 
DDS_AsyncWaitSet * DDS_AsyncWaitSet_newI(
        DDS_DomainParticipantFactory *factory,
        const struct DDS_AsyncWaitSetProperty_t *awsProperty,
        struct DDS_AsyncWaitSetListener *listener,
        struct DDS_ThreadFactory *threadFactory,
        REDAOrderedDataTypeCompareWithUserDataFunction compareHandler,
        void *compareUserData);

extern DDSCDllExport 
DDS_WaitSet * DDS_AsyncWaitSet_get_waitsetI(DDS_AsyncWaitSet *self);


DDS_SEQUENCE_IN_C(RTIOsapiThreadCpuInfoSeq, struct RTIOsapiThreadCpuInfo);

#define DDS_AsyncWaitSetThreadPoolStats_INITIALIZER \
{ \
    DDS_SEQUENCE_INITIALIZER \
}    

DDSC_VARIABLE_LENGTH_VALUE_TYPE_SUPPORT(DDS_AsyncWaitSetThreadPoolStats);

       
struct DDS_AsyncWaitSetThreadPoolStats {
    struct RTIOsapiThreadCpuInfoSeq thread_pool_info;
     
    DDSCPP_VARIABLE_LENGTH_VALUE_TYPE_SUPPORT(DDS_AsyncWaitSetThreadPoolStats)
};

extern DDSCDllExport 
void DDS_AsyncWaitSet_get_thread_pool_statsI(
        DDS_AsyncWaitSet *self,
        struct DDS_AsyncWaitSetThreadPoolStats *pool_stats);

extern DDSCDllExport
DDS_ReturnCode_t DDS_AsyncWaitSet_suspend_with_completion_token(
        DDS_AsyncWaitSet *self,
        DDS_AsyncWaitSetCompletionToken *completion_token);

extern DDSCDllExport
DDS_ReturnCode_t DDS_AsyncWaitSet_resume_with_completion_token(
        DDS_AsyncWaitSet *self,
        DDS_AsyncWaitSetCompletionToken *completion_token);


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* dds_c_asyncwaitset_impl_h */
