/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)dds_c_data.h    generated by: makeheader    Sat Mar  9 09:39:07 2024
 *
 *		built from:	data.ifc
 */

#ifndef dds_c_data_h
#define dds_c_data_h


  #ifndef dds_c_common_h
    #include "dds_c/dds_c_common.h"
  #endif
  #ifndef dds_c_infrastructure_h
    #include "dds_c/dds_c_infrastructure.h"
  #endif
  #ifndef dds_c_topic_h
    #include "dds_c/dds_c_topic.h"
  #endif
  #ifndef dds_c_publication_h
    #include "dds_c/dds_c_publication.h"
  #endif
  #ifndef dds_c_subscription_h
    #include "dds_c/dds_c_subscription.h"
  #endif
  #ifndef dds_c_domain_h
    #include "dds_c/dds_c_domain.h"
  #endif

#ifdef __cplusplus
    extern "C" {
#endif


#define NDDSUSERDllExport
struct DDS_PrintFormatProperty;


#define DDS_TYPESUPPORT_C(TTypeSupport, TData)                \
    NDDSUSERDllExport DDSCDllExport                           \
    DDS_ReturnCode_t TTypeSupport ## _register_type(          \
        DDS_DomainParticipant* participant,                   \
        const char* type_name);                               \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    DDS_ReturnCode_t TTypeSupport ## _unregister_type(        \
        DDS_DomainParticipant* participant,                   \
        const char* type_name);                               \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    const char* TTypeSupport ## _get_type_name(void);         \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    TData* TTypeSupport ## _create_data(void);                \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    TData* TTypeSupport ## _create_data_ex(                   \
        DDS_Boolean allocatePointers);                        \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    TData* TTypeSupport ## _create_data_w_params(             \
        const struct DDS_TypeAllocationParams_t * alloc_params); \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    DDS_ReturnCode_t TTypeSupport ## _delete_data(            \
    	TData* a_data);                                       \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    DDS_ReturnCode_t TTypeSupport ## _delete_data_ex(         \
    	TData* a_data, DDS_Boolean deletePointers);           \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    DDS_ReturnCode_t TTypeSupport ## _delete_data_w_params(   \
        TData* a_data,                                        \
        const struct DDS_TypeDeallocationParams_t * dealloc_params); \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    void TTypeSupport ## _print_data(const TData* a_data);    \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    DDS_ReturnCode_t TTypeSupport ## _copy_data(              \
        TData* desc, const TData* source);                    \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    DDS_ReturnCode_t TTypeSupport ## _initialize_data(        \
        TData* a_data);                                       \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    DDS_ReturnCode_t TTypeSupport ## _initialize_data_ex(     \
        TData* a_data, DDS_Boolean allocatePointers);         \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    DDS_ReturnCode_t TTypeSupport ## _initialize_data_w_params( \
        TData* a_data,                                        \
        const struct DDS_TypeAllocationParams_t * alloc_params); \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    DDS_ReturnCode_t TTypeSupport ## _finalize_data(          \
        TData* a_data);                                       \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    DDS_ReturnCode_t TTypeSupport ## _finalize_data_ex(       \
        TData* a_data, DDS_Boolean deletePointers);           \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    DDS_ReturnCode_t TTypeSupport ## _finalize_data_w_params( \
        TData* a_data,                                        \
        const struct DDS_TypeDeallocationParams_t * dealloc_params); \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    void TTypeSupport ## _finalize(void);                     \
                                                              \
    NDDSUSERDllExport DDSCDllExport                           \
    DDS_TypeCode* TTypeSupport ## _get_typecode(void);        \
                                                              \
    NDDSUSERDllExport DDSCDllExport                             \
    DDS_ReturnCode_t TTypeSupport ## _serialize_data_to_cdr_buffer(  \
        char * buffer,                                          \
        unsigned int * length,                                  \
        const TData *a_data);                                   \
                                                                \
    NDDSUSERDllExport DDSCDllExport                             \
    DDS_ReturnCode_t TTypeSupport ## _serialize_data_to_cdr_buffer_ex( \
            char *buffer,                                       \
            unsigned int *length,                               \
            const TData *a_data,                                \
            DDS_DataRepresentationId_t representation);         \
                                                                \
    NDDSUSERDllExport DDSCDllExport                             \
    DDS_ReturnCode_t TTypeSupport ## _deserialize_data_from_cdr_buffer(  \
        TData *sample,                                          \
        const char * buffer,                                    \
        unsigned int length);                                   \
                                                                \
    NDDSUSERDllExport DDSCDllExport                             \
    DDS_ReturnCode_t TTypeSupport ## _data_to_string(           \
        TData *sample,                                          \
        char *str,                                              \
        DDS_UnsignedLong *str_size,                             \
        const struct DDS_PrintFormatProperty *property)


#define DDS_DATAWRITER_C(TDataWriter, TData)                              \
    typedef struct TDataWriter TDataWriter;                               \
    NDDSUSERDllExport DDSCDllExport TDataWriter* TDataWriter ## _narrow(  \
        DDS_DataWriter* writer);                                          \
    NDDSUSERDllExport DDSCDllExport DDS_DataWriter* TDataWriter ## _as_datawriter( \
        TDataWriter* writer);                                             \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_InstanceHandle_t TDataWriter ## _register_instance(               \
        TDataWriter* self, const TData* instance_data);                   \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_InstanceHandle_t TDataWriter ## _register_instance_w_timestamp(   \
        TDataWriter* self, const TData* instance_data,                    \
        const struct DDS_Time_t* source_timestamp);                       \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_InstanceHandle_t TDataWriter ## _register_instance_w_params(      \
        TDataWriter* self, const TData* instance_data,                    \
        struct DDS_WriteParams_t* params);                          \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_ReturnCode_t TDataWriter ## _unregister_instance(                 \
        TDataWriter* self, const TData* instance_data,                    \
        const DDS_InstanceHandle_t* handle);                              \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_ReturnCode_t TDataWriter ## _unregister_instance_w_timestamp(     \
        TDataWriter* self, const TData* instance_data,                    \
        const DDS_InstanceHandle_t* handle,                               \
        const struct DDS_Time_t* source_timestamp);                       \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_ReturnCode_t TDataWriter ## _unregister_instance_w_params(        \
        TDataWriter* self, const TData* instance_data,                    \
        struct DDS_WriteParams_t* params);                          \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_ReturnCode_t TDataWriter ## _write(                               \
        TDataWriter* self, const TData* instance_data,                    \
        const DDS_InstanceHandle_t* handle);                              \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_ReturnCode_t TDataWriter ## _write_w_timestamp(                   \
        TDataWriter* self, const TData* instance_data,                    \
        const DDS_InstanceHandle_t* handle,                               \
        const struct DDS_Time_t* source_timestamp);                       \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_ReturnCode_t TDataWriter ## _write_w_params(                      \
        TDataWriter* self, const TData* instance_data,                    \
        struct DDS_WriteParams_t* params);                          \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_ReturnCode_t TDataWriter ## _dispose(                             \
        TDataWriter* self, const TData* instance_data,                    \
        const DDS_InstanceHandle_t* instance_handle);                     \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_ReturnCode_t TDataWriter ## _dispose_w_timestamp(                 \
        TDataWriter* self, const TData* instance_data,                    \
        const DDS_InstanceHandle_t* instance_handle,                      \
        const struct DDS_Time_t* source_timestamp);                       \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_ReturnCode_t TDataWriter ## _dispose_w_params(                    \
        TDataWriter* self, const TData* instance_data,                    \
        struct DDS_WriteParams_t* params);                                \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_ReturnCode_t TDataWriter ## _get_key_value(                       \
        TDataWriter* self, TData* key_holder,                             \
        const DDS_InstanceHandle_t* handle);                              \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_InstanceHandle_t TDataWriter ## _lookup_instance(                 \
        TDataWriter* self, const TData* key_holder)

#define DDS_DATAWRITER_WITH_DATA_CONSTRUCTOR_METHODS_C(TDataWriter, TData)   \
    DDS_DATAWRITER_C(TDataWriter, TData);                                 \
    NDDSUSERDllExport DDSCDllExport                                       \
    TData* TDataWriter ## _create_data(                                   \
        TDataWriter* writer);                                             \
    NDDSUSERDllExport DDSCDllExport                                       \
    TData* TDataWriter ## _create_data_w_params(                          \
            TDataWriter* writer,                                          \
            const struct DDS_TypeAllocationParams_t * alloc_params);      \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_Boolean TDataWriter ## _delete_data(TDataWriter* writer, TData*); \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_Boolean TDataWriter ## _delete_data_w_params(                     \
            TDataWriter* writer,                                          \
            TData*,                                                       \
            const struct DDS_TypeDeallocationParams_t*);                  \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_ReturnCode_t TDataWriter ## _get_loan(                            \
            TDataWriter* writer, TData** sample);                         \
    NDDSUSERDllExport DDSCDllExport                                       \
    DDS_ReturnCode_t TDataWriter ## _discard_loan(                        \
            TDataWriter* writer, TData* sample)




#define DDS_DATAREADER_C(TDataReader, TDataSeq, TData)                       \
    typedef struct TDataReader TDataReader;                                  \
                                                                             \
    NDDSUSERDllExport DDSCDllExport TDataReader* TDataReader ## _narrow(     \
        DDS_DataReader* reader);                                             \
    NDDSUSERDllExport DDSCDllExport DDS_DataReader* TDataReader ## _as_datareader(   \
        TDataReader* reader);                                                \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _read(TDataReader* self,                 \
        struct TDataSeq* received_data, struct DDS_SampleInfoSeq* info_seq,  \
        DDS_Long max_samples,                                                    \
        DDS_SampleStateMask sample_states, DDS_ViewStateMask view_states,    \
        DDS_InstanceStateMask instance_states);                              \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _take(TDataReader* self,                 \
        struct TDataSeq* received_data, struct DDS_SampleInfoSeq* info_seq,  \
        DDS_Long max_samples,                                                    \
        DDS_SampleStateMask sample_mask, DDS_ViewStateMask view_mask,        \
        DDS_InstanceStateMask instance_mask);                                \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _read_w_condition(                       \
        TDataReader* self, struct TDataSeq* received_data,                   \
        struct DDS_SampleInfoSeq* info_seq,                                  \
        DDS_Long max_samples,                                                    \
        DDS_ReadCondition* condition);                                       \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _take_w_condition(                       \
        TDataReader* self, struct TDataSeq* received_data,                   \
        struct DDS_SampleInfoSeq* info_seq,                                  \
        DDS_Long max_samples,                                                    \
        DDS_ReadCondition* condition);                                       \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _read_next_sample(                       \
        TDataReader* self, TData* received_data,                             \
        struct DDS_SampleInfo* sample_info);                                 \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _take_next_sample(                       \
        TDataReader* self, TData* received_data,                             \
        struct DDS_SampleInfo* sample_info);                                 \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _read_instance(                          \
        TDataReader* self,                                                   \
        struct TDataSeq* received_data, struct DDS_SampleInfoSeq* info_seq,  \
        DDS_Long max_samples,                                                    \
        const DDS_InstanceHandle_t* a_handle,                                \
        DDS_SampleStateMask sample_states, DDS_ViewStateMask view_states,    \
        DDS_InstanceStateMask instance_states);                              \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _take_instance(                          \
        TDataReader* self,                                                   \
        struct TDataSeq* received_data, struct DDS_SampleInfoSeq* info_seq,  \
        DDS_Long max_samples,                                                    \
        const DDS_InstanceHandle_t* a_handle,                                \
        DDS_SampleStateMask sample_states, DDS_ViewStateMask view_states,    \
        DDS_InstanceStateMask instance_states);                              \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _read_instance_w_condition(              \
        TDataReader* self,                                                   \
        struct TDataSeq* received_data, struct DDS_SampleInfoSeq* info_seq,  \
        DDS_Long max_samples,                                                \
        const DDS_InstanceHandle_t* a_handle,                                \
        DDS_ReadCondition* condition);                                       \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _take_instance_w_condition(               \
        TDataReader* self,                                                   \
        struct TDataSeq* received_data, struct DDS_SampleInfoSeq* info_seq,  \
        DDS_Long max_samples,                                                \
        const DDS_InstanceHandle_t* a_handle,                                \
        DDS_ReadCondition* condition);                                       \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _read_next_instance(                     \
        TDataReader* self,                                                   \
        struct TDataSeq* received_data, struct DDS_SampleInfoSeq* info_seq,  \
        DDS_Long max_samples,                                                    \
        const DDS_InstanceHandle_t* previous_handle,                         \
        DDS_SampleStateMask sample_states, DDS_ViewStateMask view_states,    \
        DDS_InstanceStateMask instance_states);                              \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _take_next_instance(                     \
        TDataReader* self,                                                   \
        struct TDataSeq* received_data, struct DDS_SampleInfoSeq* info_seq,  \
        DDS_Long max_samples,                                                    \
        const DDS_InstanceHandle_t* previous_handle,                         \
        DDS_SampleStateMask sample_states, DDS_ViewStateMask view_states,    \
        DDS_InstanceStateMask instance_states);                              \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _read_next_instance_w_condition(         \
        TDataReader* self,                                                   \
        struct TDataSeq* received_data, struct DDS_SampleInfoSeq* info_seq,  \
        DDS_Long max_samples,                                                \
        const DDS_InstanceHandle_t* previous_handle,                         \
        DDS_ReadCondition* condition);                                       \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _take_next_instance_w_condition(         \
        TDataReader* self,                                                   \
        struct TDataSeq* received_data, struct DDS_SampleInfoSeq* info_seq,  \
        DDS_Long max_samples,                                                \
        const DDS_InstanceHandle_t* previous_handle,                         \
        DDS_ReadCondition* condition);                                       \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _add_sample_to_remote_writer_queue(      \
        TDataReader *self,                                                   \
        const TData *local_data,                                             \
        const struct DDS_GUID_t *queue_writer_guid,                          \
        const struct DDS_WriteParams_t *write_params);                       \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _add_unregister_to_remote_writer_queue(  \
        TDataReader *self,                                                   \
        const struct DDS_GUID_t *queue_writer_guid,                          \
        const struct DDS_WriteParams_t *write_params);                       \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _add_dispose_to_remote_writer_queue(     \
        TDataReader *self,                                                   \
        const struct DDS_GUID_t *queue_writer_guid,                          \
        const struct DDS_WriteParams_t *write_params);                       \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _return_loan(                            \
        TDataReader* self,                                                   \
        struct TDataSeq* received_data, struct DDS_SampleInfoSeq* info_seq); \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _get_key_value(                          \
        TDataReader* self, TData* key_holder,                                \
        const DDS_InstanceHandle_t* handle);                                 \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_InstanceHandle_t TDataReader ## _lookup_instance(                    \
        TDataReader* self, const TData* key_holder);                         \
                                                                             \
    NDDSUSERDllExport DDSCDllExport                                          \
    DDS_ReturnCode_t TDataReader ## _is_data_consistent(                     \
        TDataReader *self,                                                   \
        DDS_Boolean *is_data_consistent,                                     \
        const TData *sample,                                                 \
        const struct DDS_SampleInfo *sample_info)



#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* dds_c_data_h */
