/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)dds_c_dynamicdata_java_impl.h    generated by: makeheader    Sat Mar  9 09:39:08 2024
 *
 *		built from:	dynamicdata_java_impl.ifc
 */

#ifndef dds_c_dynamicdata_java_impl_h
#define dds_c_dynamicdata_java_impl_h


  #ifndef dds_c_publication_h
    #include "dds_c/dds_c_dynamicdata.h"
  #endif
  #ifndef dds_c_dll_h
    #include "dds_c/dds_c_dll.h"
  #endif

#ifdef __cplusplus
    extern "C" {
#endif

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_get_long_java(
    const DDS_DynamicData * self,
    DDS_Long * value_out,
    const char * member_name,
    DDS_DynamicDataMemberId member_id);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_get_short_java(
    const DDS_DynamicData * self,
    DDS_Short * value_out,
    const char * member_name,
    DDS_DynamicDataMemberId member_id);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_get_longlong_java(
    const DDS_DynamicData * self,
    DDS_LongLong * value_out,
    const char * member_name,
    DDS_DynamicDataMemberId member_id);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_get_long_array_java(
    const DDS_DynamicData * self,
    DDS_Long * array, /* out */
    DDS_UnsignedLong * length, /* inout */
    const char * member_name,
    DDS_DynamicDataMemberId member_id);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_get_short_array_java(
    const DDS_DynamicData * self,
    DDS_Short * array, /* out */
    DDS_UnsignedLong * length, /* inout */
    const char * member_name,
    DDS_DynamicDataMemberId member_id);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_get_longlong_array_java(
    const DDS_DynamicData * self,
    DDS_LongLong * array, /* out */
    DDS_UnsignedLong * length, /* inout */
    const char * member_name,
    DDS_DynamicDataMemberId member_id);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_get_wchar_array_java(
    const DDS_DynamicData * self,
    DDS_Wchar * array, /* out */
    DDS_UnsignedLong * length, /* inout */
    const char * member_name,
    DDS_DynamicDataMemberId member_id);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_get_long_seq_java(
    const DDS_DynamicData * self,
    struct DDS_LongSeq * seq, /* inout */
    const char * member_name,
    DDS_DynamicDataMemberId member_id);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_get_short_seq_java(
    const DDS_DynamicData * self,
    struct DDS_ShortSeq * seq, /* inout */
    const char * member_name,
    DDS_DynamicDataMemberId member_id);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_get_longlong_seq_java(
    const DDS_DynamicData * self,
    struct DDS_LongLongSeq * seq, /* inout */
    const char * member_name,
    DDS_DynamicDataMemberId member_id);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_set_long_java(
    DDS_DynamicData * self,
    const char * member_name,
    DDS_DynamicDataMemberId member_id,
    DDS_Long value);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_set_short_java(
    DDS_DynamicData * self,
    const char * member_name,
    DDS_DynamicDataMemberId member_id,
    DDS_Short value);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_set_longlong_java(
    DDS_DynamicData * self,
    const char * member_name,
    DDS_DynamicDataMemberId member_id,
    DDS_LongLong value);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_set_long_array_java(
    DDS_DynamicData * self,
    const char * member_name,
    DDS_DynamicDataMemberId member_id,
    DDS_UnsignedLong length,
    const DDS_Long * array);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_set_short_array_java(
    DDS_DynamicData * self,
    const char * member_name,
    DDS_DynamicDataMemberId member_id,
    DDS_UnsignedLong length,
    const DDS_Short * array);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_set_longlong_array_java(
    DDS_DynamicData * self,
    const char * member_name,
    DDS_DynamicDataMemberId member_id,
    DDS_UnsignedLong length,
    const DDS_LongLong * array);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_set_long_seq_java(
    DDS_DynamicData * self,
    const char * member_name,
    DDS_DynamicDataMemberId member_id,
    const struct DDS_LongSeq * value);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_set_short_seq_java(
    DDS_DynamicData * self,
    const char * member_name,
    DDS_DynamicDataMemberId member_id,
    const struct DDS_ShortSeq * value);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_set_longlong_seq_java(
    DDS_DynamicData * self,
    const char * member_name,
    DDS_DynamicDataMemberId member_id,
    const struct DDS_LongLongSeq * value);



#ifdef __cplusplus
    }
#endif

#endif /* dds_c_dynamicdata_java_impl_h */
