/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)dds_c_license.h    generated by: makeheader    Sat Mar  9 09:39:08 2024
 *
 *		built from:	license.ifc
 */

#ifndef dds_c_license_h
#define dds_c_license_h



#ifndef dds_c_infrastructure_h
  #include "dds_c/dds_c_infrastructure.h"
#endif

#ifdef __cplusplus
    extern "C" {
#endif
/* RTILM_LINE_LENGTH_MAX must be large enough to hold all the fields with
   length up to RTILM_FIELD_LENGTH_MAX and the option string with length
   up to RTILM_OPTION_LENGTH_MAX in a feature line
 */
#define RTILM_LINE_LENGTH_MAX (1536)
#define RTILM_DATE_LENGTH_MAX (64)

/*
 * This needs to be large enough to fit RTI_ACTIVATION_LIBRARY_EXCEPTION_MESSAGE_MAX_SIZE
 * and whatever messages we log on top of it, if we do
 */
#define RTILM_OPTION_LENGTH_MAX (2048)

/* Return codes */
typedef enum {
    /* Ok */
    RTILM_RETCODE_OK,
    /* Matching feature, but expired. */
    RTILM_RETCODE_EXPIRED,
    /* Matching feature, but something invalid */
    RTILM_RETCODE_INVALID,
    /* File doesn't contain feature/vendor */
    RTILM_RETCODE_NOT_FOUND,
    /* No file found. */
    RTILM_RETCODE_FILE_NOT_FOUND,
    /* Bad parameters. */
    RTILM_RETCODE_BAD_PARAMETERS,
    /* Null reponse. */
    RTILM_RETCODE_NULL_RESPONSE
} RTILMRetCode;


extern DDSCDllExport
int NDDS_LM_validate(void* p_outParams, void* p_inOutParams, void* p_inParams);

extern DDSCDllExport
RTIBool NDDS_LM_get_value_from_option_string(
    char* optionValue, const char* optionString, const char* optionName);

extern DDSCDllExport
DDS_Boolean NDDS_LM_verify_activation_result(
        char *response_string,
        unsigned int response_string_size,
        const char *product_name,
        DDS_Boolean valid_mic,
        const RTILMRetCode activation_result,
        void *out_param);

extern DDSCDllExport
DDS_Boolean NDDS_LM_unload_activation_library(void);


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* dds_c_license_h */
