/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)dds_c_printformat.h    generated by: makeheader    Sat Mar  9 09:39:09 2024
 *
 *		built from:	printformat.ifc
 */

#ifndef dds_c_printformat_h
#define dds_c_printformat_h


#ifndef rtixml_infrastructure_h
  #include "rtixml/rtixml_infrastructure.h"
#endif
#ifndef dds_c_common_h
  #include "dds_c/dds_c_common.h"
#endif
#ifndef dds_c_infrastructure_h
  #include "dds_c/dds_c_infrastructure.h"
#endif
#ifdef __cplusplus
  extern "C" {
#endif


struct DDS_PrintFormat;


typedef void (*DDS_PrintFormat_printTopLevelBeginningFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const char *name,
        int indent);


typedef void (*DDS_PrintFormat_printTopLevelEndingFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const char *name,
        int indent);


typedef void (*DDS_PrintFormat_printTopLevelArrayBeginningFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const char *name,
        int indent);


typedef void (*DDS_PrintFormat_printTopLevelArrayEndingFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const char *name,
        int indent);


typedef void (*DDS_PrintFormat_printComplexTypeBeginningFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const char *name,
        int indent);


typedef void (*DDS_PrintFormat_printComplexTypeEndingFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const char *name,
        int indent);


typedef void (*DDS_PrintFormat_printPrimitiveTypeBeginningFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const char *name,
        int indent);


typedef void (*DDS_PrintFormat_printPrimitiveTypeEndingFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const char *name,
        int indent);


typedef void (*DDS_PrintFormat_printArrayBeginningFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const char *name,
        int indent);


typedef void (*DDS_PrintFormat_printArrayEndingFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const char *name,
        int indent);


typedef void (*DDS_PrintFormat_printComplexItemWithNameBeginningFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const char *name,
        DDS_UnsignedLong member_index,
        int indent);


typedef void (*DDS_PrintFormat_printComplexItemBeginningFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        DDS_UnsignedLong member_index,
        int indent);


typedef void (*DDS_PrintFormat_printComplexItemWithNameEndingFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const char *name,
        DDS_UnsignedLong member_index,
        int indent);


typedef void (*DDS_PrintFormat_printComplexItemEndingFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        DDS_UnsignedLong member_index,
        int indent);


typedef void (*DDS_PrintFormat_printPrimitiveItemBeginningFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        DDS_UnsignedLong member_index,
        int indent);


typedef void (*DDS_PrintFormat_printPrimitiveItemEndingFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        DDS_UnsignedLong member_index,
        int indent);


typedef void (*DDS_PrintFormat_printArrayItemBeginningFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        DDS_UnsignedLong member_index,
        int indent);


typedef void (*DDS_PrintFormat_printArrayItemEndingFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        DDS_UnsignedLong member_index,
        int indent);


typedef void (*DDS_PrintFormat_printUnionDiscriminatorBeginningFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        int indent);


typedef void (*DDS_PrintFormat_printUnionDiscriminatorEndingFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        int indent);


typedef void (*DDS_PrintFormat_printIndentFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        int count);


typedef void (*DDS_PrintFormat_printUnsetOptionalMemberBeginningFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const char *name,
        int indent);


typedef void (*DDS_PrintFormat_printUnsetOptionalMemberEndingFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const char *name,
        int indent);


typedef void (*DDS_PrintFormat_printEscapedCharFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const DDS_Char c);


typedef void (*DDS_PrintFormat_printEscapedStringFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const DDS_Char *str);


typedef void (*DDS_PrintFormat_printEscapedWCharFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const DDS_Wchar str);


typedef void (*DDS_PrintFormat_printEscapedWStringFnc)(
        struct DDS_PrintFormat *self,
        struct RTIXMLSaveContext *dst,
        const DDS_Wchar *str,
        const unsigned int strLength);


typedef struct DDS_PrintFormat {
    DDS_PrintFormat_printTopLevelBeginningFnc
        print_top_level_beginning;

    DDS_PrintFormat_printTopLevelEndingFnc
        print_top_level_ending;

    DDS_PrintFormat_printTopLevelArrayBeginningFnc
        print_top_level_array_beginning;

    DDS_PrintFormat_printTopLevelArrayEndingFnc
        print_top_level_array_ending;

    DDS_PrintFormat_printComplexTypeBeginningFnc
        print_complex_type_beginning;

    DDS_PrintFormat_printComplexTypeEndingFnc
        print_complex_type_ending;

    DDS_PrintFormat_printPrimitiveTypeBeginningFnc
        print_primitive_type_beginning;

    DDS_PrintFormat_printPrimitiveTypeEndingFnc
        print_primitive_type_ending;

    DDS_PrintFormat_printArrayBeginningFnc
        print_array_beginning;

    DDS_PrintFormat_printArrayEndingFnc
        print_array_ending;

    DDS_PrintFormat_printComplexItemWithNameBeginningFnc
        print_complex_item_with_name_beginning;

    DDS_PrintFormat_printComplexItemBeginningFnc
        print_complex_item_beginning;

    DDS_PrintFormat_printComplexItemWithNameEndingFnc
        print_complex_item_with_name_ending;

    DDS_PrintFormat_printComplexItemEndingFnc
        print_complex_item_ending;

    DDS_PrintFormat_printPrimitiveItemBeginningFnc
        print_primitive_item_beginning;

    DDS_PrintFormat_printPrimitiveItemEndingFnc
        print_primitive_item_ending;

    DDS_PrintFormat_printArrayItemBeginningFnc
        print_array_item_beginning;

    DDS_PrintFormat_printArrayItemEndingFnc
        print_array_item_ending;

    DDS_PrintFormat_printUnionDiscriminatorBeginningFnc
        print_union_discriminator_beginning;

    DDS_PrintFormat_printUnionDiscriminatorEndingFnc
        print_union_discriminator_ending;

    DDS_PrintFormat_printUnsetOptionalMemberBeginningFnc
        print_unset_optional_member_beginning;

    DDS_PrintFormat_printUnsetOptionalMemberEndingFnc
        print_unset_optional_member_ending;

    DDS_PrintFormat_printIndentFnc
        print_indent;

    DDS_PrintFormat_printEscapedCharFnc
        print_escaped_char;

    DDS_PrintFormat_printEscapedStringFnc
        print_escaped_string;

    DDS_PrintFormat_printEscapedWCharFnc
        print_escaped_wchar;

    DDS_PrintFormat_printEscapedWStringFnc
        print_escaped_wstring;

    const char *hexadecimal_opening_delimiter;

    const char *hexadecimal_closing_delimiter;

    const char *character_opening_delimiter;

    const char *character_closing_delimiter;

    const char *string_opening_delimiter;

    const char *string_closing_delimiter;

    const char *enum_opening_delimiter;

    const char *enum_closing_delimiter;
    
    const char *null_representation;

    const char *nan_representation;

    const char *inf_representation;

    const char *element_separator;

    const char *newline_representation;

    const char *indent_representation;

    int indent_factor;

    int initial_indent;

    DDS_Boolean enable_top_level_type_printing;

    DDS_Boolean enable_union_discriminator_printing;

    DDS_Boolean enable_enum_as_string_printing;
} DDS_PrintFormat;


#define DDS_PrintFormat_INITIALIZER \
    {(DDS_PrintFormat_printTopLevelBeginningFnc)NULL, \
    (DDS_PrintFormat_printTopLevelEndingFnc)NULL, \
    (DDS_PrintFormat_printTopLevelArrayBeginningFnc)NULL, \
    (DDS_PrintFormat_printTopLevelArrayEndingFnc)NULL, \
    (DDS_PrintFormat_printComplexTypeBeginningFnc)NULL, \
    (DDS_PrintFormat_printComplexTypeEndingFnc)NULL, \
    (DDS_PrintFormat_printPrimitiveTypeBeginningFnc)NULL, \
    (DDS_PrintFormat_printPrimitiveTypeEndingFnc)NULL, \
    (DDS_PrintFormat_printArrayBeginningFnc)NULL, \
    (DDS_PrintFormat_printArrayEndingFnc)NULL, \
    (DDS_PrintFormat_printComplexItemWithNameBeginningFnc)NULL, \
    (DDS_PrintFormat_printComplexItemBeginningFnc)NULL, \
    (DDS_PrintFormat_printComplexItemWithNameEndingFnc)NULL,\
    (DDS_PrintFormat_printComplexItemEndingFnc)NULL,\
    (DDS_PrintFormat_printPrimitiveItemBeginningFnc)NULL, \
    (DDS_PrintFormat_printPrimitiveItemEndingFnc)NULL,\
    (DDS_PrintFormat_printArrayItemBeginningFnc)NULL, \
    (DDS_PrintFormat_printArrayItemEndingFnc)NULL,\
    (DDS_PrintFormat_printUnionDiscriminatorBeginningFnc)NULL, \
    (DDS_PrintFormat_printUnionDiscriminatorEndingFnc)NULL, \
    (DDS_PrintFormat_printUnsetOptionalMemberBeginningFnc)NULL, \
    (DDS_PrintFormat_printUnsetOptionalMemberEndingFnc)NULL, \
    (DDS_PrintFormat_printIndentFnc)NULL, \
    (DDS_PrintFormat_printEscapedCharFnc)NULL, \
    (DDS_PrintFormat_printEscapedStringFnc)NULL, \
    (DDS_PrintFormat_printEscapedWCharFnc) NULL, \
    (DDS_PrintFormat_printEscapedWStringFnc) NULL, \
    NULL,\
    NULL,\
    NULL,\
    NULL,\
    NULL,\
    NULL,\
    NULL,\
    NULL,\
    NULL,\
    NULL,\
    NULL,\
    NULL,\
    NULL,\
    NULL,\
    3,\
    0,\
    DDS_BOOLEAN_FALSE,\
    DDS_BOOLEAN_TRUE,\
    DDS_BOOLEAN_TRUE}

typedef enum {
    /*e \dref_PrintFormatKind_DEFAULT_PRINT_FORMAT 
     */
    DDS_DEFAULT_PRINT_FORMAT     = 0,
    /*e \dref_PrintFormatKind_XML_PRINT_FORMAT 
     */
    DDS_XML_PRINT_FORMAT         = 1,
    /*e \dref_PrintFormatKind_JSON_PRINT_FORMAT 
     */
    DDS_JSON_PRINT_FORMAT        = 2
} DDS_PrintFormatKind;

extern DDSCDllExport
DDS_ReturnCode_t DDS_PrintFormat_initialize(
        struct DDS_PrintFormat *self,
        DDS_PrintFormatKind formatKind);

extern DDSCDllExport
DDS_ReturnCode_t DDS_PrintFormat_finalize(
        struct DDS_PrintFormat *self,
        DDS_PrintFormatKind formatKind);

extern DDSCDllExport
struct DDS_PrintFormat * DDS_PrintFormat_new(
        DDS_PrintFormatKind formatKind);

extern DDSCDllExport
void DDS_PrintFormat_delete(
        struct DDS_PrintFormat *self,
        DDS_PrintFormatKind formatKind);

extern DDSCDllExport
DDS_Boolean DDS_PrintFormat_is_valid(
        struct DDS_PrintFormat *self);

typedef struct DDS_PrintFormatProperty {

    /*e \dref_PrintFormatProperty_kind */
    DDS_PrintFormatKind kind;

    /*e \dref_PrintFormatProperty_pretty_print */
    DDS_Boolean pretty_print;

    /*e \dref_PrintFormatProperty_enum_as_int */
    DDS_Boolean enum_as_int;

    /*e \dref_PrintFormatProperty_include_root_elements */
    DDS_Boolean include_root_elements;

  #ifdef RTI_CPP
    /*e 
     */
    DDS_PrintFormatProperty() : 
        kind(DDS_DEFAULT_PRINT_FORMAT),
        pretty_print(DDS_BOOLEAN_TRUE),
        enum_as_int(DDS_BOOLEAN_FALSE),
        include_root_elements(DDS_BOOLEAN_TRUE) {}
  #endif

} DDS_PrintFormatProperty;

extern DDSCDllVariable 
const struct DDS_PrintFormatProperty DDS_PRINT_FORMAT_PROPERTY_DEFAULT;


#define DDS_PrintFormatProperty_INITIALIZER { \
    DDS_DEFAULT_PRINT_FORMAT, \
    DDS_BOOLEAN_TRUE, \
    DDS_BOOLEAN_FALSE, \
    DDS_BOOLEAN_TRUE \
  }

extern DDSCDllExport
DDS_ReturnCode_t DDS_PrintFormatProperty_to_print_format(
        const DDS_PrintFormatProperty *self, 
        DDS_PrintFormat *printFormat);


#ifdef __cplusplus
    }   /* extern "C" */
#endif

#endif /* dds_c_printformat_h */
