/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)dds_c_sample_processor_impl.h    generated by: makeheader    Sat Mar  9 09:39:09 2024
 *
 *		built from:	sample_processor_impl.ifc
 */

#ifndef dds_c_sample_processor_impl_h
#define dds_c_sample_processor_impl_h



#ifndef dds_c_sample_processor_h
  #include "dds_c/dds_c_sample_processor.h"
#endif
#ifdef __cplusplus
    extern "C" {
#endif
        


typedef void (*DDS_SampleProcessorListener_OnReaderAttachedCallback)(
        void *listener_data,
        DDS_Condition *condition);


typedef void (*DDS_SampleProcessorListener_OnReaderAlreadyAttachedCallback)(
        void *listener_data,
        DDS_Condition *condition,
        struct DDS_SampleHandler *sample_handler);


typedef void (*DDS_SampleProcessorListener_OnReaderDetachedCallback)(
        void *listener_data,
        DDS_Condition *condition);


struct DDS_SampleProcessorListener {
    void *listener_data;    
    DDS_SampleProcessorListener_OnReaderAttachedCallback
            on_reader_attached;

    DDS_SampleProcessorListener_OnReaderAlreadyAttachedCallback
            on_reader_already_attached;
    
    DDS_SampleProcessorListener_OnReaderDetachedCallback
            on_reader_detached;
};


#define DDS_SampleProcessorListener_INITIALIZER { \
        NULL, \
        NULL, \
        NULL, \
        NULL}

extern DDSCDllExport
DDS_ReturnCode_t
DDS_SampleProcessor_get_sample_handler_from_conditionI(
        struct DDS_SampleHandler *handler_out,
        DDS_Condition *condition);

extern DDSCDllExport
DDS_SampleProcessor*
DDS_SampleProcessor_new_with_params(
        const struct DDS_AsyncWaitSetProperty_t *aws_property,
        DDS_AsyncWaitSet *aws,
        struct DDS_SampleProcessorListener *listener);


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* dds_c_sample_processor_impl_h */
