/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)dds_cpp_flowcontroller.h    generated by: makeheader    Sat Mar  9 09:40:23 2024
 *
 *		built from:	flowcontroller.ifcxx
 */

#ifndef dds_cpp_flowcontroller_h
#define dds_cpp_flowcontroller_h


  #ifndef dds_cpp_dll_h
    #include "dds_cpp/dds_cpp_dll.h"
  #endif
  #ifndef dds_cpp_infrastructure_h
    #include "dds_cpp/dds_cpp_infrastructure.h"
  #endif
  #ifndef dds_c_flowcontroller_h
    #include "dds_c/dds_c_flowcontroller.h"
  #endif

class DDSFlowController_impl;

class DDSDomainParticipant;

class DDSCPPDllExport DDSFlowController {
  public: 

    /*i
      @brief Get the underlying implementation class object.	  
     */
    virtual DDSFlowController_impl* get_impl_FlowControllerI() 
        = 0;

  public: 

    /*e \dref_FlowController_set_property
     */
    virtual DDS_ReturnCode_t set_property(
        const struct DDS_FlowControllerProperty_t &prop)
        = 0;
    
    /*e \dref_FlowController_get_property
     */
    virtual DDS_ReturnCode_t get_property(
        struct DDS_FlowControllerProperty_t &prop)
        = 0;

    /*e \dref_FlowController_trigger_flow
     */
    virtual DDS_ReturnCode_t trigger_flow()
        = 0;

    /*e \dref_FlowController_get_name
     */
    virtual const char* get_name() 
	    = 0;

    /*e \dref_FlowController_get_participant
     */
    virtual DDSDomainParticipant* get_participant() 
	    = 0;

  protected: 
    virtual ~DDSFlowController();
};

#endif /* dds_cpp_flowcontroller_h */
