/* $Id$

 (c) Copyright, Real-Time Innovations, 2005-2016.
 All rights reserved.
 No duplications, whole or partial, manual or electronic, may be made
 without express written permission.  Any such copies, or
 revisions thereof, must display this notice unaltered.
 This code contains trade secrets of Real-Time Innovations, Inc.

modification history
--------------------
5.0.1,06jul13,fcs Added w_params functions
1.5a,17sep09,fcs Added Raw1kPlugin_g_doubleIndirectionTest
1.4d,29aug09,fcs Double pointer indirection and dropSample
                 in deserialize function
1.4d,04aug09,eh  Add multi-encapsulation support
1.0s,28feb08,fcs Removed instance parameter from
                 serializedSampleToKeyhash
1.0s,18feb08,fcs Changed (de)serialize_key signature
1.0s,15jan07,fcs Added Raw1kPlugin_get_max_size_serializedData
1.0s,27dec07,fcs Added (de)serialize_encapsulation
1.0o,05apr04,fcs Added serializeKey, deseiralizeKey and 
                 getMaxSerializedKey
===================================================================== */

/*
THERE HAVE BEEN CHANGES TO THE GENERATED CODE IN THIS FILE.
SEARCH FOR 'customization' TO SEE ALL CHANGES

This file was generated from Raw1k.idl using "rtiddsgen".
The rtiddsgen tool is part of the RTI Connext distribution.
For more information, type 'rtiddsgen -help' at a command shell
or consult the RTI Connext manual.
*/

#ifndef Raw1kPlugin_891625379_h
#define Raw1kPlugin_891625379_h

#include "Raw1k.h"

struct RTICdrStream;

#ifndef pres_typePlugin_h
#include "pres/pres_typePlugin.h"
#endif

#if (defined(RTI_WIN32) || defined (RTI_WINCE) || defined(RTI_INTIME)) && defined(NDDS_USER_DLL_EXPORT)
/* If the code is building on Windows, start exporting symbols.
*/
#undef NDDSUSERDllExport
#define NDDSUSERDllExport __declspec(dllexport)
#endif

/* customization: new global variable */
extern RTIBool Raw1kPlugin_g_doubleIndirectionTest;

/* The type used to store keys for instances of type struct
* AnotherSimple.
*
* By default, this type is struct Raw1k
* itself. However, if for some reason this choice is not practical for your
* system (e.g. if sizeof(struct Raw1k)
* is very large), you may redefine this typedef in terms of another type of
* your choosing. HOWEVER, if you define the KeyHolder type to be something
* other than struct AnotherSimple, the
* following restriction applies: the key of struct
* Raw1k must consist of a
* single field of your redefined KeyHolder type and that field must be the
* first field in struct Raw1k.
*/
typedef  struct Raw1k Raw1kKeyHolder;

#define Raw1kPlugin_get_sample PRESTypePluginDefaultEndpointData_getSample 
#define Raw1kPlugin_get_buffer PRESTypePluginDefaultEndpointData_getBuffer 
#define Raw1kPlugin_return_buffer PRESTypePluginDefaultEndpointData_returnBuffer 

#define Raw1kPlugin_get_key PRESTypePluginDefaultEndpointData_getKey 
#define Raw1kPlugin_return_key PRESTypePluginDefaultEndpointData_returnKey

#define Raw1kPlugin_create_sample PRESTypePluginDefaultEndpointData_createSample 
#define Raw1kPlugin_destroy_sample PRESTypePluginDefaultEndpointData_deleteSample 

/* --------------------------------------------------------------------------------------
Support functions:
* -------------------------------------------------------------------------------------- */

NDDSUSERDllExport extern Raw1k*
Raw1kPluginSupport_create_data_w_params(
    const struct DDS_TypeAllocationParams_t * alloc_params);

NDDSUSERDllExport extern Raw1k*
Raw1kPluginSupport_create_data_ex(RTIBool allocate_pointers);

NDDSUSERDllExport extern Raw1k*
Raw1kPluginSupport_create_data(void);

NDDSUSERDllExport extern RTIBool 
Raw1kPluginSupport_copy_data(
    Raw1k *out,
    const Raw1k *in);

NDDSUSERDllExport extern void 
Raw1kPluginSupport_destroy_data_w_params(
    Raw1k *sample,
    const struct DDS_TypeDeallocationParams_t * dealloc_params);

NDDSUSERDllExport extern void 
Raw1kPluginSupport_destroy_data_ex(
    Raw1k *sample,RTIBool deallocate_pointers);

NDDSUSERDllExport extern void 
Raw1kPluginSupport_destroy_data(
    Raw1k *sample);

NDDSUSERDllExport extern void 
Raw1kPluginSupport_print_data(
    const Raw1k *sample,
    const char *desc,
    unsigned int indent);

NDDSUSERDllExport extern Raw1k*
Raw1kPluginSupport_create_key_ex(RTIBool allocate_pointers);

NDDSUSERDllExport extern Raw1k*
Raw1kPluginSupport_create_key(void);

NDDSUSERDllExport extern void 
Raw1kPluginSupport_destroy_key_ex(
    Raw1kKeyHolder *key,RTIBool deallocate_pointers);

NDDSUSERDllExport extern void 
Raw1kPluginSupport_destroy_key(
    Raw1kKeyHolder *key);

/* ----------------------------------------------------------------------------
Callback functions:
* ---------------------------------------------------------------------------- */

NDDSUSERDllExport extern PRESTypePluginParticipantData 
Raw1kPlugin_on_participant_attached(
    void *registration_data, 
    const struct PRESTypePluginParticipantInfo *participant_info,
    RTIBool top_level_registration, 
    void *container_plugin_context,
    RTICdrTypeCode *typeCode);

NDDSUSERDllExport extern void 
Raw1kPlugin_on_participant_detached(
    PRESTypePluginParticipantData participant_data);

NDDSUSERDllExport extern PRESTypePluginEndpointData 
Raw1kPlugin_on_endpoint_attached(
    PRESTypePluginParticipantData participant_data,
    const struct PRESTypePluginEndpointInfo *endpoint_info,
    RTIBool top_level_registration, 
    void *container_plugin_context);

NDDSUSERDllExport extern void 
Raw1kPlugin_on_endpoint_detached(
    PRESTypePluginEndpointData endpoint_data);

NDDSUSERDllExport extern void    
Raw1kPlugin_return_sample(
    PRESTypePluginEndpointData endpoint_data,
    Raw1k *sample,
    void *handle);    

NDDSUSERDllExport extern RTIBool 
Raw1kPlugin_copy_sample(
    PRESTypePluginEndpointData endpoint_data,
    Raw1k *out,
    const Raw1k *in);

/* ----------------------------------------------------------------------------
(De)Serialize functions:
* ------------------------------------------------------------------------- */

NDDSUSERDllExport extern RTIBool 
Raw1kPlugin_serialize(
    PRESTypePluginEndpointData endpoint_data,
    const Raw1k *sample,
    struct RTICdrStream *stream, 
    RTIBool serialize_encapsulation,
    RTIEncapsulationId encapsulation_id,
    RTIBool serialize_sample, 
    void *endpoint_plugin_qos);

NDDSUSERDllExport extern RTIBool 
Raw1kPlugin_deserialize_sample(
    PRESTypePluginEndpointData endpoint_data,
    Raw1k *sample, 
    struct RTICdrStream *cdrStream,
    RTIBool deserialize_encapsulation,
    RTIBool deserialize_sample, 
    void *endpoint_plugin_qos);

NDDSUSERDllExport extern RTIBool
Raw1kPlugin_serialize_to_cdr_buffer(
    char * buffer,
    unsigned int * length,
    const Raw1k *sample); 

NDDSUSERDllExport extern RTIBool
Raw1kPlugin_serialize_to_cdr_buffer_ex(
        char *buffer,
        unsigned int *length,
        const Raw1k *sample,
        DDS_DataRepresentationId_t representation);

NDDSUSERDllExport extern RTIBool 
Raw1kPlugin_deserialize(
    PRESTypePluginEndpointData endpoint_data,
    Raw1k **sample, 
    RTIBool * drop_sample,
    struct RTICdrStream *cdrStream,
    RTIBool deserialize_encapsulation,
    RTIBool deserialize_sample, 
    void *endpoint_plugin_qos);

NDDSUSERDllExport extern RTIBool
Raw1kPlugin_deserialize_from_cdr_buffer(
    Raw1k *sample,
    const char * buffer,
    unsigned int length);    

NDDSUSERDllExport extern DDS_ReturnCode_t 
Raw1kPlugin_data_to_string(
    const Raw1k *sample,
    char *str,
    DDS_UnsignedLong *str_size,
    const DDS_PrintFormatProperty *property);

NDDSUSERDllExport extern RTIBool
Raw1kPlugin_skip(
    PRESTypePluginEndpointData endpoint_data,
    struct RTICdrStream *stream, 
    RTIBool skip_encapsulation,  
    RTIBool skip_sample, 
    void *endpoint_plugin_qos);

NDDSUSERDllExport extern unsigned int 
Raw1kPlugin_get_serialized_sample_max_size_ex(
    PRESTypePluginEndpointData endpoint_data,
    RTIBool * overflow,
    RTIBool include_encapsulation,
    RTIEncapsulationId encapsulation_id,
    unsigned int current_alignment);    

NDDSUSERDllExport extern unsigned int 
Raw1kPlugin_get_serialized_sample_max_size(
    PRESTypePluginEndpointData endpoint_data,
    RTIBool include_encapsulation,
    RTIEncapsulationId encapsulation_id,
    unsigned int current_alignment);

NDDSUSERDllExport extern unsigned int 
Raw1kPlugin_get_serialized_sample_min_size(
    PRESTypePluginEndpointData endpoint_data,
    RTIBool include_encapsulation,
    RTIEncapsulationId encapsulation_id,
    unsigned int current_alignment);

NDDSUSERDllExport extern unsigned int
Raw1kPlugin_get_serialized_sample_size(
    PRESTypePluginEndpointData endpoint_data,
    RTIBool include_encapsulation,
    RTIEncapsulationId encapsulation_id,
    unsigned int current_alignment,
    const Raw1k * sample);

/* --------------------------------------------------------------------------------------
Key Management functions:
* -------------------------------------------------------------------------------------- */
NDDSUSERDllExport extern PRESTypePluginKeyKind 
Raw1kPlugin_get_key_kind(void);

NDDSUSERDllExport extern unsigned int 
Raw1kPlugin_get_serialized_key_max_size_ex(
    PRESTypePluginEndpointData endpoint_data,
    RTIBool * overflow,
    RTIBool include_encapsulation,
    RTIEncapsulationId encapsulation_id,
    unsigned int current_alignment);

NDDSUSERDllExport extern unsigned int 
Raw1kPlugin_get_serialized_key_max_size(
    PRESTypePluginEndpointData endpoint_data,
    RTIBool include_encapsulation,
    RTIEncapsulationId encapsulation_id,
    unsigned int current_alignment);

NDDSUSERDllExport extern RTIBool 
Raw1kPlugin_serialize_key(
    PRESTypePluginEndpointData endpoint_data,
    const Raw1k *sample,
    struct RTICdrStream *cdrStream,
    RTIBool serialize_encapsulation,
    RTIEncapsulationId encapsulation_id,
    RTIBool serialize_key,
    void *endpoint_plugin_qos);

NDDSUSERDllExport extern RTIBool 
Raw1kPlugin_deserialize_key_sample(
    PRESTypePluginEndpointData endpoint_data,
    Raw1k * sample,
    struct RTICdrStream *cdrStream,
    RTIBool deserialize_encapsulation,
    RTIBool deserialize_key,
    void *endpoint_plugin_qos);

NDDSUSERDllExport extern RTIBool 
Raw1kPlugin_deserialize_key(
    PRESTypePluginEndpointData endpoint_data,
    Raw1k ** sample,
    RTIBool * drop_sample,
    struct RTICdrStream *cdrStream,
    RTIBool deserialize_encapsulation,
    RTIBool deserialize_key,
    void *endpoint_plugin_qos);

NDDSUSERDllExport extern RTIBool
Raw1kPlugin_serialized_sample_to_key(
    PRESTypePluginEndpointData endpoint_data,
    Raw1k *sample,
    struct RTICdrStream *stream, 
    RTIBool deserialize_encapsulation,  
    RTIBool deserialize_key, 
    void *endpoint_plugin_qos);

NDDSUSERDllExport extern RTIBool 
Raw1kPlugin_instance_to_key(
    PRESTypePluginEndpointData endpoint_data,
    Raw1kKeyHolder *key, 
    const Raw1k *instance);

NDDSUSERDllExport extern RTIBool 
Raw1kPlugin_key_to_instance(
    PRESTypePluginEndpointData endpoint_data,
    Raw1k *instance, 
    const Raw1kKeyHolder *key);

NDDSUSERDllExport extern RTIBool 
Raw1kPlugin_instance_to_keyhash(
        PRESTypePluginEndpointData endpoint_data,
        DDS_KeyHash_t *keyhash,
        const Raw1k *instance,
        RTIEncapsulationId encapsulationId);

NDDSUSERDllExport extern RTIBool 
Raw1kPlugin_serialized_sample_to_keyhash(
    PRESTypePluginEndpointData endpoint_data,
    struct RTICdrStream *stream, 
    DDS_KeyHash_t *keyhash,
    RTIBool deserialize_encapsulation,
    void *endpoint_plugin_qos); 

/* Plugin Functions */
NDDSUSERDllExport extern struct PRESTypePlugin*
Raw1kPlugin_new(void);

NDDSUSERDllExport extern void
Raw1kPlugin_delete(struct PRESTypePlugin *);

#if (defined(RTI_WIN32) || defined (RTI_WINCE) || defined(RTI_INTIME)) && defined(NDDS_USER_DLL_EXPORT)
/* If the code is building on Windows, stop exporting symbols.
*/
#undef NDDSUSERDllExport
#define NDDSUSERDllExport
#endif

#endif /* Raw1kPlugin_891625379_h */

