#ifndef OMG_DDS_TOPIC_DETAIL_TOPIC_FWD_HPP_
#define OMG_DDS_TOPIC_DETAIL_TOPIC_FWD_HPP_

/* Copyright 2010, Object Management Group, Inc.
 * Copyright 2010, PrismTech, Corp.
 * Copyright 2010, Real-Time Innovations, Inc.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// IMPORTANT: macros.hpp must be the first RTI header included in every header
// file so that symbols are exported correctly on Windows
#include <dds/core/macros.hpp>

#include <rti/topic/topicfwd.hpp>

namespace dds { namespace topic { 

    template <typename D>
    class TParticipantBuiltinTopicData;

    template <typename D>
    class TTopicBuiltinTopicData;

    template <typename D>
    class TPublicationBuiltinTopicData;

    template <typename D>
    class TSubscriptionBuiltinTopicData;

    template <typename D>
    class TFilter;

    template <typename D>
    class TBuiltinTopicKey;

    namespace detail {

    using rti::topic::TopicImpl;

    using rti::topic::TopicDescriptionImpl;

    using rti::topic::ContentFilteredTopicImpl;

    typedef TParticipantBuiltinTopicData<rti::topic::ParticipantBuiltinTopicDataImpl>
        ParticipantBuiltinTopicData;

    typedef TTopicBuiltinTopicData<rti::topic::TopicBuiltinTopicDataImpl>
        TopicBuiltinTopicData;

    typedef TPublicationBuiltinTopicData<rti::topic::PublicationBuiltinTopicDataImpl>
        PublicationBuiltinTopicData;

    typedef TSubscriptionBuiltinTopicData<rti::topic::SubscriptionBuiltinTopicDataImpl>
        SubscriptionBuiltinTopicData;

    typedef dds::topic::TFilter<rti::topic::FilterImpl> Filter;

    typedef dds::topic::TBuiltinTopicKey<rti::topic::BuiltinTopicKeyImpl>
            BuiltinTopicKey;

    }  // namespace detail

} } // namespace dds::topic

#endif // OMG_DDS_TOPIC_DETAIL_TOPIC_FWD_HPP_
