/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)osapi_activityContext_impl.h    generated by: makeheader    Sat Mar  9 09:37:07 2024
 *
 *		built from:	activityContext_impl.ifc
 */

#ifndef osapi_activityContext_impl_h
#define osapi_activityContext_impl_h


#ifdef __cplusplus
extern "C" {
#endif



#define RTIOsapiActivityContextSupport_assertContextTss( \
        addContextTssToGlobalList__) \
    RTIOsapiContextSupport_assertContextTss( \
            RTI_OSAPI_ACTIVITY_CONTEXT_INDEX, \
            (addContextTssToGlobalList__), \
            RTI_OSAPI_CONTEXT_STACK_SIZE_DEFAULT, \
            RTI_TRUE)

#define RTIOsapiActivityContextSupport_assertContextTssWithParams( \
        addContextTssToGlobalList__, \
        activityContextMaxEntryCount__) \
    RTIOsapiContextSupport_assertContextTss( \
            RTI_OSAPI_ACTIVITY_CONTEXT_INDEX, \
            (addContextTssToGlobalList__), \
            (activityContextMaxEntryCount__), \
            RTI_TRUE)

#define RTIOsapiActivityContextScope_beginWithEntries( \
        activityContextMaxEntryCountArg__) \
    RTIOsapiContextScope_begin() \
    RTI_UINT32 activityContextEntryIndex__ = 0; \
    const RTI_UINT32 activityContextMaxEntryCount__ = \
            (activityContextMaxEntryCountArg__); \
    struct RTIOsapiActivityContextStackEntry activityContextEntry__[ \
            (activityContextMaxEntryCountArg__)]

#define RTIOsapiActivityContextScope_beginWithEntriesAndParams( \
        activityContextMaxEntryCount__, \
        activityContextMaxParamsCountArg__) \
    RTIOsapiActivityContextScope_beginWithEntries(activityContextMaxEntryCount__); \
    void *activityContextParamsList__[(activityContextMaxParamsCountArg__)]; \
    RTI_UINT32 activityContextParamIndex__ = 0; \
    const RTI_UINT32 activityContextMaxParamsCount__ = \
            (activityContextMaxParamsCountArg__)

/*
 * Only in the PURIFY_TEST:
 * When overflow entering an entry or params into the context.
 * Log a fatal message and allocate 1B so it will be detected in the Valgrind
 * plan using purify. Also disabled in ASan build since LSan issues cannot be
 * suppressed in GCC.
 */
#if defined(PURIFY_TEST) && !defined(RTI_ADDRESS_SANITIZER_IS_ENABLED)
  #define RTIOsapiActivityContextScope_reportEnterOverflowFailure() \
    { \
        void *__detectEnterOverflowFailure = \
                RTIOsapiHeap_mallocWithoutHeapHeader(1); \
        /* In order to avoid warning: unused variable __detectEnterOverflowFailure */ \
        RTIOsapiUtility_unusedParameter(__detectEnterOverflowFailure); \
        RTILogMessage_print( \
                RTI_LOG_PRINT_FORMAT_MASK_ALL, \
                RTI_LOG_BIT_FATAL_ERROR, \
                MODULE_OSAPI, \
                &RTI_LOG_PRECONDITION_FAILURE_s, \
                "overflow entering entries or params"); \
    }
#else
  #define RTIOsapiActivityContextScope_reportEnterOverflowFailure() \
    ((void) 0);
#endif


#define RTIOsapiActivityContextScope_enterActivity( \
        activityContext__, \
        formatTemplate__) \
    /* Check not overflow the array of entries */ \
    if (activityContextEntryIndex__ < activityContextMaxEntryCount__) { \
        activityContextEntry__[activityContextEntryIndex__].format = \
                (formatTemplate__); \
        activityContextEntry__[activityContextEntryIndex__].kind = \
                RTI_OSAPI_ACTIVITY_CONTEXT_ENTRY_KIND_ACTIVITY; \
        RTIOsapiActivityContext_enter( \
                (activityContext__), \
                &activityContextEntry__[activityContextEntryIndex__++]); \
    } else { \
        RTIOsapiActivityContextScope_reportEnterOverflowFailure(); \
    }

#define RTIOsapiActivityContextScope_enterActivityWithParams( \
        activityContext__, \
        formatTemplate__, \
        ...) \
    /* Check not overflow the array of entries */ \
    if (activityContextEntryIndex__ < activityContextMaxEntryCount__) { \
        activityContextEntry__[activityContextEntryIndex__].params = \
                &activityContextParamsList__[activityContextParamIndex__]; \
        if (RTIOsapiActivityContext_getParamList( \
                activityContextParamsList__, \
                &activityContextParamIndex__, \
                activityContextMaxParamsCount__, \
                (formatTemplate__), \
                __VA_ARGS__)) { \
            activityContextEntry__[activityContextEntryIndex__].format = (formatTemplate__); \
            activityContextEntry__[activityContextEntryIndex__].kind = \
                    RTI_OSAPI_ACTIVITY_CONTEXT_ENTRY_KIND_ACTIVITY_WITH_PARAMS; \
            RTIOsapiActivityContext_enter( \
                    (activityContext__), \
                    &activityContextEntry__[activityContextEntryIndex__++]); \
        } else { \
            RTIOsapiActivityContextScope_reportEnterOverflowFailure(); \
        } \
    } else { \
        RTIOsapiActivityContextScope_reportEnterOverflowFailure(); \
    }

#define RTIOsapiActivityContextScope_enterResource( \
        activityContext__, \
        formatTemplate__, \
        resource__) \
    /* Check not overflow the array of entries */ \
    if (activityContextEntryIndex__ < activityContextMaxEntryCount__) { \
        activityContextEntry__[activityContextEntryIndex__].kind = \
                RTI_OSAPI_ACTIVITY_CONTEXT_ENTRY_KIND_RESOURCE; \
        activityContextEntry__[activityContextEntryIndex__].format = \
                (formatTemplate__); \
        activityContextEntry__[activityContextEntryIndex__].params = \
                (char *) (resource__); \
        RTIOsapiActivityContext_enter( \
                (activityContext__), \
                &activityContextEntry__[activityContextEntryIndex__++]); \
    } else { \
        RTIOsapiActivityContextScope_reportEnterOverflowFailure(); \
    }

#define RTIOsapiActivityContextScope_enterResourceWithParams( \
        activityContext__, \
        formatTemplate__, \
        ...) \
    /* Check not overflow the array of entries */ \
    if (activityContextEntryIndex__ < activityContextMaxEntryCount__) { \
        activityContextEntry__[activityContextEntryIndex__].params = \
                &activityContextParamsList__[activityContextParamIndex__]; \
        if (RTIOsapiActivityContext_getParamList( \
                activityContextParamsList__, \
                &activityContextParamIndex__, \
                activityContextMaxParamsCount__, \
                (formatTemplate__), \
                __VA_ARGS__)) { \
            activityContextEntry__[activityContextEntryIndex__].kind = \
                    RTI_OSAPI_ACTIVITY_CONTEXT_ENTRY_KIND_RESOURCE_WITH_PARAMS; \
            activityContextEntry__[activityContextEntryIndex__].format = (formatTemplate__); \
            RTIOsapiActivityContext_enter( \
                    (activityContext__), \
                    &activityContextEntry__[activityContextEntryIndex__++]); \
        } else { \
            RTIOsapiActivityContextScope_reportEnterOverflowFailure(); \
        } \
    } else { \
        RTIOsapiActivityContextScope_reportEnterOverflowFailure(); \
    }

#define RTIOsapiActivityContextScope_enterResourceGuidWithParams( \
        activityContext__, \
        formatTemplate__, \
        ...) \
    /* Check not overflow the array of entries */ \
    if (activityContextEntryIndex__ < activityContextMaxEntryCount__) { \
        activityContextEntry__[activityContextEntryIndex__].params = \
                &activityContextParamsList__[activityContextParamIndex__]; \
        if (RTIOsapiActivityContext_getParamList( \
                activityContextParamsList__, \
                &activityContextParamIndex__, \
                activityContextMaxParamsCount__, \
                (formatTemplate__), \
                __VA_ARGS__)) { \
            activityContextEntry__[activityContextEntryIndex__].kind = \
                    RTI_OSAPI_ACTIVITY_CONTEXT_ENTRY_KIND_RESOURCE_GUID_WITH_PARAMS; \
            activityContextEntry__[activityContextEntryIndex__].format = \
                    (formatTemplate__); \
            RTIOsapiActivityContext_enter( \
                    (activityContext__), \
                    &activityContextEntry__[activityContextEntryIndex__++]); \
        } else { \
            RTIOsapiActivityContextScope_reportEnterOverflowFailure(); \
        } \
    } else { \
        RTIOsapiActivityContextScope_reportEnterOverflowFailure(); \
    }

#define RTIOsapiActivityContextScope_leave(activityContext__) \
    if (activityContextEntryIndex__ > 0) { \
        RTIOsapiActivityContext_leave((activityContext__) /* activityContext */); \
        activityContextEntryIndex__--; \
    }

#define RTIOsapiActivityContextScope_end(activityContext__) \
    RTIOsapiActivityContext_leaveGroup( \
            (activityContext__), \
            activityContextEntryIndex__); \
    RTIOsapiContextScope_end()

#define RTIOsapiActivityContext_enter(activityContext__, entry__) \
    RTIOsapiContext_enter( \
            (activityContext__), \
            RTI_OSAPI_ACTIVITY_CONTEXT_INDEX, \
            (entry__))

#define RTIOsapiActivityContext_enterPair(activityContext__, __entry1, __entry2) \
    RTIOsapiContext_enterPair( \
            (activityContext__), \
            RTI_OSAPI_ACTIVITY_CONTEXT_INDEX, \
            (__entry1), \
            (__entry2))

#define RTIOsapiActivityContext_leave(self__) \
    RTIOsapiContext_leave((self__), RTI_OSAPI_ACTIVITY_CONTEXT_INDEX)

#define RTIOsapiActivityContext_leaveGroup(activityContext__, __groupSize) \
        RTIOsapiContext_leaveGroup( \
                (activityContext__), \
                RTI_OSAPI_ACTIVITY_CONTEXT_INDEX, \
                (__groupSize))

#define RTIOsapiActivityContext_getDepth() \
    RTIOsapiContext_getDepth(RTI_OSAPI_ACTIVITY_CONTEXT_INDEX)

#define RTIOsapiActivityContextStackEntry_initialize(kind__) \
    { \
        (kind__), /* kind */ \
        NULL, /* format */ \
        NULL /* params */ \
    }

#define RTIOsapiActivityContext_getCategory(self__, category__) \
    RTIOsapiContext_getCategory( \
            (self__), \
            (category__), \
            RTI_OSAPI_ACTIVITY_CONTEXT_INDEX)

#define RTIOsapiActivityContext_setCategory(self__, category__) \
    RTIOsapiContext_setCategory( \
            (self__), \
            RTI_OSAPI_ACTIVITY_CONTEXT_INDEX, \
            (category__))

#define RTIOsapiActivityContext_addCategory(self__, category__) \
    RTIOsapiContext_addCategory( \
            (self__), \
            RTI_OSAPI_ACTIVITY_CONTEXT_INDEX, \
            (category__))

#define RTIOsapiActivityContext_resetCategory(self__, category__) \
    RTIOsapiContext_resetCategory( \
            (self__), \
            RTI_OSAPI_ACTIVITY_CONTEXT_INDEX, \
            (category__))

#define RTIOsapiActivityContext_addAndCacheCategory( \
        self__, \
        cachedCategory__, \
        category__) \
    RTIOsapiContext_addAndCacheCategory( \
            (self__), \
            (cachedCategory__), \
            RTI_OSAPI_ACTIVITY_CONTEXT_INDEX, \
            (category__))

/*
 * @brief Checks if two category masks have the same category bit set.
 *
 * @param RTILogCategoryMask
 * @param RTILogCategoryMask
 *
 * @return 0 if two categories don't have at least one common category set
 * @return non 0 if two categories share one, or more, common category bits
 */
#define RTIOsapiActivityContext_isCategorySet( \
        categoryA__, \
        categoryB__) \
    ((categoryA__ ) & (categoryB__))



#ifdef __cplusplus
} /* extern "C" */
#endif


#endif /* osapi_activityContext_impl_h */
