/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)osapi_process.h    generated by: makeheader    Sat Mar  9 09:37:09 2024
 *
 *		built from:	process.ifc
 */

#ifndef osapi_process_h
#define osapi_process_h


  #ifndef osapi_type_h
    #include "osapi/osapi_type.h"
  #endif
  #ifndef osapi_ntptime_h
    #include "osapi/osapi_ntptime.h"
  #endif
  #ifndef osapi_dll_h
    #include "osapi/osapi_dll.h"
  #endif

#ifdef __cplusplus
    extern "C" {
#endif

extern RTIOsapiDllExport RTI_UINT64 RTIOsapiProcess_getId(void);

extern RTIOsapiDllExport void RTIOsapiProcess_resetId(void);

extern RTIOsapiDllExport RTIBool RTIOsapiProcess_isAlive(RTI_UINT64 pidIn);


struct RTIOsapiProcessMemoryInfo {
    /*e @brief Resident memory size */
    RTI_UINT64 physicalMemory;
    /*e @brief Virtual memory size */
    RTI_UINT64 totalMemory;
};


#define RTIOsapiProcessMemoryInfo_INITIALIZER \
{ \
    0, \
    0 \
}

extern RTIOsapiDllExport
RTIBool RTIOsapiProcess_getMemoryInfo(struct RTIOsapiProcessMemoryInfo *info);



#if defined(RTI_IOS)
  #define RTI_OSAPI_PROCESS_MEMORY_INFO_SUPPORTED (0)
#elif defined(RTI_LINUX) \
    || defined(RTI_DARWIN) \
    || defined(RTI_QNX) \
    || defined(RTI_WIN32) \
    || defined(RTI_INTIME)
  #define RTI_OSAPI_PROCESS_MEMORY_INFO_SUPPORTED (1)
#else
  #define RTI_OSAPI_PROCESS_MEMORY_INFO_SUPPORTED (0)
#endif



struct RTIOsapiProcessCpuInfo {
    struct RTINtpTime userCpuUsage;
    struct RTINtpTime kernelCpuUsage;
};


#define RTIOsapiProcessCpuInfo_INITIALIZER \
{ \
    RTI_NTP_TIME_ZERO, \
    RTI_NTP_TIME_ZERO \
}

extern RTIOsapiDllExport
RTIBool RTIOsapiProcess_getCpuInfo(struct RTIOsapiProcessCpuInfo *info);



#if defined(RTI_UNIX) \
    || defined(RTI_QNX) \
    || defined(RTI_WIN32)
  #define RTI_OSAPI_PROCESS_CPU_INFO_SUPPORTED (1)
#else
  #define RTI_OSAPI_PROCESS_CPU_INFO_SUPPORTED (0)
#endif



#if (defined(RTI_LINUX) || defined(RTI_QNX) || defined(RTI_DARWIN))
  #include <sys/resource.h>
#endif

#if (defined(RTI_64BIT) && (defined(RTI_SOL2) || defined(RTI_QNX) || defined(RTI_ANDROID)))
  #define RTIOsapiProcessRLimit rlimit64
#elif (defined(RTI_LINUX) || defined(RTI_SOL2) || defined(RTI_QNX) || defined(RTI_DARWIN))
  #define RTIOsapiProcessRLimit rlimit
#else
  struct RTIOsapiProcessRLimit {
      RTI_UINT64 rlim_cur;  /* Soft limit */
      RTI_UINT64 rlim_max;  /* Hard limit (ceiling for rlim_cur) */
  };
#endif

extern RTIOsapiDllExport
int RTIOsapiProcess_getrlimit(
        int resource,
        struct RTIOsapiProcessRLimit *limit);


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#include "osapi/osapi_process_impl.h"


#endif /* osapi_process_h */
