/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)osapi_rtpsTime_impl.h    generated by: makeheader    Sat Mar  9 09:37:09 2024
 *
 *		built from:	rtpsTime_impl.ifc
 */

#ifndef osapi_rtpsTime_impl_h
#define osapi_rtpsTime_impl_h



#ifdef __cplusplus
    extern "C" {
#endif



#define RTIRtpsTime_compare(time1, time2) \
    ((((time1).sec) > ((time2).sec)) ? 1 : \
        ((((time1).sec) < ((time2).sec)) ? -1 : \
            ((((time1).frac) > ((time2).frac)) ? 1 : \
                ((((time1).frac) < ((time2).frac)) ? -1 : 0))))

#define RTIRtpsTime_isInfinite(time__) (((void *) (time__) == NULL) || \
                                    (((time__)->sec == RTI_RTPS_TIME_SEC_MAX) && \
                                    ((time__)->frac == RTI_RTPS_TIME_FRAC_MAX)))
#define RTIRtpsTime_isInvalid(time__) (((void *) (time__) != NULL) && \
                                (((time__)->sec == RTI_RTPS_TIME_SEC_INVALID) && \
                                ((time__)->frac == RTI_RTPS_TIME_FRAC_INVALID)))
#define RTIRtpsDuration_isInfinite(duration__) (((void *) (duration__) == NULL) || \
                                    (((duration__)->sec == RTI_RTPS_DURATION_SEC_INFINITE) && \
                                    ((duration__)->frac == RTI_RTPS_DURATION_FRAC_INFINITE)))
#define RTIRtpsDuration_isAuto(duration__) (((void *) (duration__) == NULL) || \
                                    (((duration__)->sec == RTI_RTPS_DURATION_SEC_AUTO) && \
                                    ((duration__)->frac == RTI_RTPS_DURATION_FRAC_AUTO)))
#define RTIRtpsDuration_isInvalid(duration__) (((void *) (duration__) == NULL) || \
                                    (((duration__)->sec == RTI_RTPS_DURATION_SEC_INVALID) && \
                                    ((duration__)->frac == RTI_RTPS_DURATION_FRAC_INVALID)))

#define RTIRtpsTime_fromNtptime(rtpsTime__, time__) \
{ \
    if (RTINtpTime_isInfinite((time__))) { \
        (rtpsTime__)->sec = RTI_RTPS_TIME_SEC_INFINITE; \
        (rtpsTime__)->frac = RTI_RTPS_TIME_FRAC_INFINITE; \
    } else if (RTINtpTime_isInvalid((time__))) { \
        (rtpsTime__)->sec = RTI_RTPS_TIME_SEC_INVALID; \
        (rtpsTime__)->frac = RTI_RTPS_TIME_FRAC_INVALID; \
    } else if (RTINtpTime_isAuto((time__))) { \
        (rtpsTime__)->sec = RTI_RTPS_TIME_SEC_AUTO; \
        (rtpsTime__)->frac = RTI_RTPS_TIME_FRAC_AUTO; \
    } else { \
        (rtpsTime__)->sec = (RTI_UINT32) (time__)->sec; \
        (rtpsTime__)->frac = (time__)->frac; \
    } \
}

#define RTIRtpsTime_toNtptime(rtpsTime__, time__) \
{ \
    if (RTIRtpsTime_isInfinite(rtpsTime__)) { \
        (time__)->sec = RTI_NTP_TIME_SEC_MAX; \
        (time__)->frac = RTI_NTP_TIME_FRAC_MAX; \
    } else if (RTIRtpsTime_isInvalid(rtpsTime__)) { \
        (time__)->sec = RTI_NTP_TIME_SEC_INVALID; \
        (time__)->frac = RTI_NTP_TIME_FRAC_INVALID; \
    } else { \
        (time__)->sec = (RTI_INT64) (rtpsTime__)->sec; \
        (time__)->frac = (rtpsTime__)->frac; \
    } \
}

#define RTIRtpsDuration_fromNtptime(rtpsDuration__, time__) \
{ \
    if (RTINtpTime_isInfinite(time__)) { \
        (rtpsDuration__)->sec = RTI_RTPS_DURATION_SEC_INFINITE; \
        (rtpsDuration__)->frac = RTI_RTPS_DURATION_FRAC_INFINITE; \
    } else if ((time__)->sec > (RTI_INT64) RTI_RTPS_DURATION_SEC_INFINITE) { \
        (rtpsDuration__)->sec = RTI_RTPS_DURATION_SEC_INFINITE; \
        (rtpsDuration__)->frac = RTI_RTPS_DURATION_FRAC_INFINITE; \
    } else if (RTINtpTime_isInvalid((time__))) { \
        (rtpsDuration__)->sec = RTI_RTPS_DURATION_SEC_INVALID; \
        (rtpsDuration__)->frac = RTI_RTPS_DURATION_FRAC_INVALID; \
    } else if (RTINtpTime_isAuto((time__))) { \
        (rtpsDuration__)->sec = RTI_RTPS_DURATION_SEC_AUTO; \
        (rtpsDuration__)->frac = RTI_RTPS_DURATION_FRAC_AUTO; \
    } else { \
        (rtpsDuration__)->sec = (RTI_INT32) (time__)->sec; \
        (rtpsDuration__)->frac = (time__)->frac; \
    } \
}

#define RTIRtpsDuration_toNtptime(rtpsDuration__, time__) \
{ \
    if (RTIRtpsDuration_isInfinite(rtpsDuration__)) { \
        (time__)->sec = RTI_NTP_TIME_SEC_MAX; \
        (time__)->frac = RTI_NTP_TIME_FRAC_MAX; \
    } else if (RTIRtpsDuration_isInvalid(rtpsDuration__)) { \
        (time__)->sec = RTI_NTP_TIME_SEC_INVALID; \
        (time__)->frac = RTI_NTP_TIME_FRAC_INVALID; \
    } else if (RTIRtpsDuration_isAuto(rtpsDuration__)) { \
        (time__)->sec = RTI_NTP_TIME_SEC_AUTO; \
        (time__)->frac = RTI_NTP_TIME_FRAC_AUTO; \
    } else { \
        (time__)->sec = (RTI_INT64) (rtpsDuration__)->sec; \
        (time__)->frac = (rtpsDuration__)->frac; \
    } \
}



#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* osapi_rtpsTime_impl_h */
