/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)osapi_rwLock.h    generated by: makeheader    Sat Mar  9 09:37:09 2024
 *
 *		built from:	rwLock.ifc
 */

#ifndef osapi_rwLock_h
#define osapi_rwLock_h


  #ifndef log_common_h
    #include "log/log_common.h"
  #endif
  #ifndef osapi_log_h
    #include "osapi/osapi_log.h"
  #endif

  #ifndef osapi_type_h
    #include "osapi/osapi_type.h"
  #endif
  
  #ifndef osapi_errorCode_h
    #include "osapi/osapi_errorCode.h"
  #endif

  #if defined(RTI_VXWORKS)
    #include "osapi/osapi_vxVersions.h"
    #include <sys/time.h>
  #elif defined(RTI_WIN32)
    #include <sys/timeb.h>
  #elif defined(RTI_UNIX) || defined(RTI_LYNX) || defined(RTI_QNX) || defined(RTI_INTIME)
      #if defined(RTI_LYNX) && !defined(RTI_LYNXOS_SE) && !defined(RTI_LYNX500)
        #include <time.h>
      #else
        #include <sys/time.h>
      #endif
  #elif defined(RTI_INTY)
    #include <INTEGRITY.h>
  #endif

  #if defined(RTI_OSAPI_POSIX_RWLOCK_SUPPORTED)
    #include <pthread.h>
  #endif

  #include "osapi/osapi_ntptime.h"

  #ifdef __cplusplus
    extern "C" {
  #endif

struct RTIOsapiRWLock; /* forward declare */

extern RTIOsapiDllExport struct RTIOsapiRWLock* RTIOsapiRWLock_new(void);

extern RTIOsapiDllExport void RTIOsapiRWLock_delete(struct RTIOsapiRWLock *self);

extern RTIOsapiDllExport RTIOsapiConcurrencyErrorCode RTIOsapiRWLock_lockReadLock(
        struct RTIOsapiRWLock *self,
        const struct RTINtpTime *blockDuration);

extern RTIOsapiDllExport RTIOsapiConcurrencyErrorCode RTIOsapiRWLock_unlockReadLock(
        struct RTIOsapiRWLock *self);

extern RTIOsapiDllExport RTIOsapiConcurrencyErrorCode RTIOsapiRWLock_lockWriteLock(
        struct RTIOsapiRWLock *self,
        const struct RTINtpTime *blockDuration);

extern RTIOsapiDllExport RTIOsapiConcurrencyErrorCode RTIOsapiRWLock_unlockWriteLock(
        struct RTIOsapiRWLock *self);


  #ifdef __cplusplus
    }   /* extern "C" */
  #endif


#endif /* osapi_rwLock_h */
