/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)pres_instanceState.h    generated by: makeheader    Sat Mar  9 09:38:36 2024
 *
 *		built from:	instanceState.ifc
 */

#ifndef pres_instanceState_h
#define pres_instanceState_h


 #ifndef osapi_type_h
    #include "osapi/osapi_type.h"
 #endif
 #ifndef reda_sequenceNumber_h
    #include "reda/reda_sequenceNumber.h"
 #endif
 #ifndef reda_fastBuffer_h
    #include "reda/reda_fastBuffer.h"
 #endif
 #ifndef commend_activeFacade_h
    #include "commend/commend_activeFacade.h"
 #endif
 #ifndef pres_dll_h
    #include "pres/pres_dll.h"
 #endif
 #ifndef pres_common_h
    #include "pres/pres_common.h"
 #endif

#ifdef __cplusplus
extern "C" {
#endif



struct PRESInstanceStateRequestDispatchInfo {
    struct REDASequenceNumber lastPhysicalSN;
    struct MIGRtpsGuid writerGuid;
    MIGRtpsObjectId writerGroupOid;
    MIGRtpsObjectId readerGroupOid;
    RTI_UINT32 writerSessionId;
    struct MIGRtpsGuid readerGuid;
};


#define PRES_INSTANCE_STATE_REQUEST_DISPATCH_INFO_DEFAULT \
  { \
    REDA_SEQUENCE_NUMBER_ZERO, /* lastPhysicalSN */\
    MIG_RTPS_GUID_UNKNOWN, /* writerGuid */\
    MIG_RTPS_OBJECT_ID_UNKNOWN, /* writerGroupOid */\
    MIG_RTPS_OBJECT_ID_UNKNOWN, /* readerGroupOid */\
    0, /* writerSessionId */\
    MIG_RTPS_GUID_UNKNOWN /* readerGuid */\
  }


struct PRESInstanceStateRequestData {
    /*i
     * The last physical sequence number we received from the writer. We are
     * requesting any instance state transitions that occurred after this
     * sequence number
     */
    struct REDASequenceNumber lastPhysicalSn;

    /*i
     * The GUID of the writer we are requesting instance state transitions from
     */
    struct MIGRtpsGuid writerGuid;

    /*i
     * The OID of the writer's group. This is needed on the writer side to look
     * up the writer in the writer table.
     */
    MIGRtpsObjectId writerGroupOid;

    /*i
     * The OID of the reader's group. This is needed on the reader side to look
     * up the reader in the reader table. It is copied into the IST response
     * on the writer side so that it will be available to the reader.
     */
    MIGRtpsObjectId readerGroupOid;

    /*i
     * The session whose transitions we are interested in. This is needed on the
     * writer side to look up the writer in the writer table.
     */
    RTI_UINT32 writerSessionId;
};


#define PRESInstanceStateRequestData_INITIALIZER \
  { \
    REDA_SEQUENCE_NUMBER_ZERO, /* lastPhysicalSn */ \
    MIG_RTPS_GUID_ZERO, /* writerGuid */ \
    MIG_RTPS_OBJECT_ID_UNKNOWN, /* writerGroupOid */ \
    MIG_RTPS_OBJECT_ID_UNKNOWN, /* readerGroupOid */ \
    0 /* writerSessionId */ \
  }


#ifdef __cplusplus
}   /* extern "C" */

#endif

#endif /* pres_instanceState_h */
