/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)pres_psService_impl.h    generated by: makeheader    Sat Mar  9 09:38:36 2024
 *
 *		built from:	psService_impl.ifc
 */

#ifndef pres_psService_impl_h
#define pres_psService_impl_h


#ifdef __cplusplus
    extern "C" {
#endif


    /*
     * These definitions check when a QoS Policy contains the default value
     * specified by the OMG standard. If a policy already contains the default
     * values we do not need to propagate the policy during discovery. Any other
     * DDS implementation should assume the default value for those policies
     * that have not been propagated.
     */

#define PRESPublicationGroupOid_isDefault(groupOid) \
    ((*groupOid) == MIG_RTPS_OBJECT_ID_UNKNOWN)

#define PRESSubscriptionGroupOid_isDefault(groupOid) \
    (PRESPublicationGroupOid_isDefault(groupOid))

#define PRESPublicationTypeCode_isDefault(typeCode) \
    ((*typeCode) == NULL)

#define PRESSubscriptionTypeCode_isDefault(typeCode) \
    (PRESPublicationTypeCode_isDefault(typeCode))

#define PRESPublicationTypeObject_isDefault(typeObject) \
    ((*typeObject) == NULL)

#define PRESSubscriptionTypeObject_isDefault(typeObject) \
    (PRESPublicationTypeObject_isDefault(typeObject))

/* Default kind: PRES_RELIABLE_RELIABILITY_QOS */
#define PRESPublicationReliabilityQosPolicy_isDefault(reliabilityQosPolicy) \
    ((reliabilityQosPolicy)->kind == PRES_RELIABLE_RELIABILITY_QOS \
    && (reliabilityQosPolicy)->maxBlockingTime.sec == 0 \
    && (reliabilityQosPolicy)->maxBlockingTime.frac == 429496729) /* 100ms srcTimeTol */

/* Default kind: PRES_BEST_EFFORT_RELIABILITY_QOS */
#define PRESSubscriptionReliabilityQosPolicy_isDefault(reliabilityQosPolicy) \
    ((reliabilityQosPolicy)->kind == PRES_BEST_EFFORT_RELIABILITY_QOS \
    && (reliabilityQosPolicy)->maxBlockingTime.sec == 0 \
    && (reliabilityQosPolicy)->maxBlockingTime.frac == 429496729) /* 100ms srcTimeTol */

#define PRESPublicationReliabilityQosPolicyAcknowledgmentKind_isDefault(acknowledgmentKind) \
    ((*acknowledgmentKind) == PRES_PROTOCOL_ACKNOWLEDGMENT_MODE)

#define PRESSubscriptionReliabilityQosPolicyAcknowledgmentKind_isDefault(acknowledgmentKind) \
    (PRESPublicationReliabilityQosPolicyAcknowledgmentKind_isDefault(acknowledgmentKind))

#define PRESPublicationInstanceStateConsistencyKind_isDefault(isrKind__) \
    ((*isrKind__) == PRES_NO_RECOVER_INSTANCE_STATE_CONSISTENCY)

#define PRESSubscriptionInstanceStateConsistencyKind_isDefault(isrKind__) \
    (PRESPublicationInstanceStateConsistencyKind_isDefault(isrKind__))

#define PRESSubscriptionMinimumSeparation_isDefault(minimumSeparation) \
    ((minimumSeparation)->sec == 0 \
    && (minimumSeparation)->frac == 0)

#define PRESPublicationExpectsAck_isDefault(expectsAck) \
    ((*expectsAck) == PRES_PS_PUBLICATION_PARAMETER_EXPECTS_ACK_DEFAULT)

#define PRESPublicationMaxSampleSerializedSize_isDefault(maxSampleSerializedSize) \
    ((*maxSampleSerializedSize) == PRES_PS_PUBLICATION_PARAMETER_MAX_SAMPLE_SERIALIZED_SIZE_DEFAULT)

#define PRESPublicationPersistence_isDefault(persistence) \
    ((persistence)->sec == 0 \
    && (persistence)->frac == 0)

#define PRESPublicationLivelinessQosPolicy_isDefault(livelinessQosPolicy) \
    ((livelinessQosPolicy)->kind == PRES_AUTOMATIC_LIVELINESS_QOS \
    && (livelinessQosPolicy)->assertionsPerLeaseDuration == 3 \
    && (livelinessQosPolicy)->leaseDuration.sec == RTI_NTP_TIME_SEC_MAX \
    && (livelinessQosPolicy)->leaseDuration.frac == RTI_NTP_TIME_FRAC_MAX)

#define PRESSubscriptionLivelinessQosPolicy_isDefault(livelinessQosPolicy) \
    (PRESPublicationLivelinessQosPolicy_isDefault(livelinessQosPolicy))

#define PRESPublicationDurabilityQosPolicy_isDefault(durabilityQosPolicy) \
    ((durabilityQosPolicy)->kind == PRES_VOLATILE_DURABILITY_QOS \
    && PRESSubscriptionDurabilityQosPolicyDirectCommunication_isDefault(durabilityQosPolicy))

#define PRESSubscriptionDurabilityQosPolicyKind_isDefault(durabilityQosPolicy) \
    ((durabilityQosPolicy)->kind == PRES_VOLATILE_DURABILITY_QOS)

#define PRESSubscriptionDurabilityQosPolicyDirectCommunication_isDefault(durabilityQosPolicy) \
    ((durabilityQosPolicy)->directCommunication)

#define PRESPublicationDurabilityServiceQosPolicy_isDefault(durabilityServiceQosPolicy) \
    ((durabilityServiceQosPolicy)->serviceCleanupDelay.sec == 0 \
    && (durabilityServiceQosPolicy)->serviceCleanupDelay.frac == 0 \
    && (durabilityServiceQosPolicy)->history.kind == PRES_KEEP_LAST_HISTORY_QOS \
    && (durabilityServiceQosPolicy)->history.depth == 1 \
    && (durabilityServiceQosPolicy)->resourceLimits.sampleCount.initial == 2 \
    && (durabilityServiceQosPolicy)->resourceLimits.sampleCount.maximal == REDA_FAST_BUFFER_POOL_UNLIMITED \
    && (durabilityServiceQosPolicy)->resourceLimits.sampleCount.increment == REDA_FAST_BUFFER_POOL_UNLIMITED \
    && (durabilityServiceQosPolicy)->resourceLimits.instanceCount.initial == 2 \
    && (durabilityServiceQosPolicy)->resourceLimits.instanceCount.maximal == REDA_FAST_BUFFER_POOL_UNLIMITED \
    && (durabilityServiceQosPolicy)->resourceLimits.instanceCount.increment == REDA_FAST_BUFFER_POOL_UNLIMITED \
    && (durabilityServiceQosPolicy)->resourceLimits.maxSamplesPerInstance == REDA_FAST_BUFFER_POOL_UNLIMITED \
    && (durabilityServiceQosPolicy)->resourceLimits.instanceHashBuckets == 1)

#define PRESPublicationOwnershipQosPolicy_isDefault(ownershipQosPolicy) \
    ((ownershipQosPolicy)->kind == PRES_SHARED_OWNERSHIP_QOS)

#define PRESSubscriptionOwnershipQosPolicy_isDefault(ownershipQosPolicy) \
    (PRESPublicationOwnershipQosPolicy_isDefault(ownershipQosPolicy))

#define PRESPublicationPresentationQosPolicy_isDefault(presentationQosPolicy) \
    ((presentationQosPolicy)->accessScope == PRES_INSTANCE_PRESENTATION_QOS \
    && !(presentationQosPolicy)->coherentAccess \
    && !(presentationQosPolicy)->orderedAccess)

#define PRESSubscriptionPresentationQosPolicy_isDefault(presentationQosPolicy) \
    (PRESPublicationPresentationQosPolicy_isDefault(presentationQosPolicy))

#define PRESPublicationDestinationOrderQosPolicy_isDefault(destinationOrderQosPolicy) \
    ((destinationOrderQosPolicy)->kind == PRES_BY_RECEPTION_TIMESTAMP_DESTINATIONORDER_QOS \
    && (destinationOrderQosPolicy)->scope == PRES_INSTANCE_SCOPE_DESTINATIONORDER_QOS \
    && (destinationOrderQosPolicy)->srcTimeTol.sec == 0 \
    && (destinationOrderQosPolicy)->srcTimeTol.frac == 429496729) /* 100ms srcTimeTol */

#define PRESSubscriptionDestinationOrderQosPolicy_isDefault(destinationOrderQosPolicy) \
    ((destinationOrderQosPolicy)->kind == PRES_BY_RECEPTION_TIMESTAMP_DESTINATIONORDER_QOS \
    && (destinationOrderQosPolicy)->scope == PRES_INSTANCE_SCOPE_DESTINATIONORDER_QOS \
    && (destinationOrderQosPolicy)->srcTimeTol.sec == 30 \
    && (destinationOrderQosPolicy)->srcTimeTol.frac == 0)

#define PRESPublicationDeadlineQosPolicy_isDefault(deadlineQosPolicy) \
    ((deadlineQosPolicy)->deadlinePeriod.sec == RTI_NTP_TIME_SEC_MAX \
    && (deadlineQosPolicy)->deadlinePeriod.frac == RTI_NTP_TIME_FRAC_MAX)

#define PRESSubscriptionDeadlineQosPolicy_isDefault(deadlineQosPolicy) \
    (PRESPublicationDeadlineQosPolicy_isDefault(deadlineQosPolicy))

#define PRESPublicationLatencyBudgetQosPolicy_isDefault(latencyBudgetQosPolicy) \
    ((latencyBudgetQosPolicy)->duration.sec == 0 \
    && (latencyBudgetQosPolicy)->duration.frac == 0)

#define PRESSubscriptionLatencyBudgetQosPolicy_isDefault(latencyBudgetQosPolicy) \
    (PRESPublicationLatencyBudgetQosPolicy_isDefault(latencyBudgetQosPolicy))

#define PRESPublicationLifespanQosPolicy_isDefault(lifespanQosPolicy) \
    ((lifespanQosPolicy)->duration.sec == RTI_NTP_TIME_SEC_MAX \
    && (lifespanQosPolicy)->duration.frac == RTI_NTP_TIME_FRAC_MAX)

#define PRESPublicationUserDataQosPolicy_isEmpty(userDataQosPolicy) \
    (PRESSequenceOctet_isEmpty((userDataQosPolicy)->data))

#define PRESSubscriptionUserDataQosPolicy_isEmpty(userDataQosPolicy) \
    (PRESPublicationUserDataQosPolicy_isEmpty(userDataQosPolicy))

#define PRESPublicationGroupDataQosPolicy_isEmpty(groupDataQosPolicy) \
    (PRESSequenceOctet_isEmpty((groupDataQosPolicy)->data))

#define PRESSubscriptionGroupDataQosPolicy_isEmpty(groupDataQosPolicy) \
    (PRESPublicationGroupDataQosPolicy_isEmpty(groupDataQosPolicy))

#define PRESPublicationTopicDataQosPolicy_isEmpty(topicDataQosPolicy) \
    (PRESSequenceOctet_isEmpty((topicDataQosPolicy)->data))

#define PRESSubscriptionTopicDataQosPolicy_isEmpty(topicDataQosPolicy) \
    (PRESPublicationTopicDataQosPolicy_isEmpty(topicDataQosPolicy))

#define PRESPublicationPartitionQosPolicy_isEmpty(partitionQosPolicy) \
    ((partitionQosPolicy)->name._length == 0 \
    || (partitionQosPolicy)->name.str == NULL)

#define PRESSubscriptionPartitionQosPolicy_isEmpty(partitionQosPolicy) \
    (PRESPublicationPartitionQosPolicy_isEmpty(partitionQosPolicy))

#define PRESPublicationLocatorFilterQosProperty_isEmpty(locatorFilterQosProperty) \
    ((locatorFilterQosProperty)->data._seq_length == 0 \
    || (locatorFilterQosProperty)->data._seq_buffer == NULL)

#define PRESPublicationPropertyQosPolicy_isEmpty(propertyQosPolicy) \
    (PRESSequenceOctet_isEmpty((propertyQosPolicy)->data))

#define PRESSubscriptionPropertyQosPolicy_isEmpty(propertyQosPolicy) \
    (PRESPublicationPropertyQosPolicy_isEmpty(propertyQosPolicy))

#define PRESPublicationDataTagQosPolicy_isEmpty(dataTagQosPolicy) \
    (PRESSequenceOctet_isEmpty((dataTagQosPolicy)->data))

#define PRESSubscriptionDataTagQosPolicy_isEmpty(dataTagQosPolicy) \
    (PRESPublicationDataTagQosPolicy_isEmpty(dataTagQosPolicy))

#define PRESPublicationDataRepresentationQosPolicy_isDefault(dataRepresentationQosPolicy) \
    (((dataRepresentationQosPolicy)->value._length == 0 \
    || (dataRepresentationQosPolicy)->value._buffer == NULL \
    || ((dataRepresentationQosPolicy)->value._length == 1 \
        && (dataRepresentationQosPolicy)->value._buffer[0] \
            == PRES_XCDR_DATA_REPRESENTATION)) \
    && ((dataRepresentationQosPolicy)->compressionSettings.compressionIds \
        == PRES_COMPRESSION_ID_NONE))

#define PRESSubscriptionDataRepresentationQosPolicy_isDefault( \
        dataRepresentationQosPolicy) \
    (PRESPublicationDataRepresentationQosPolicy_isDefault( \
        dataRepresentationQosPolicy))

#define PRESPublicationVirtualGuid_isDefault(virtualGuid) \
    ((virtualGuid)->prefix.hostId == MIG_RTPS_HOST_ID_UNKNOWN \
    && (virtualGuid)->prefix.appId == MIG_RTPS_APP_ID_UNKNOWN \
    && (virtualGuid)->prefix.instanceId == MIG_RTPS_INSTANCE_ID_UNKNOWN \
    && (virtualGuid)->objectId == MIG_RTPS_OBJECT_ID_UNKNOWN)

#define PRESSubscriptionVirtualGuid_isDefault(virtualGuid) \
    (PRESPublicationVirtualGuid_isDefault(virtualGuid))

#define PRESPublicationGroupVirtualGuid_isDefault(groupVirtualGuid) \
    ((groupVirtualGuid)->prefix.hostId == MIG_RTPS_HOST_ID_UNKNOWN \
    && (groupVirtualGuid)->prefix.appId == MIG_RTPS_APP_ID_UNKNOWN \
    && (groupVirtualGuid)->prefix.instanceId == MIG_RTPS_INSTANCE_ID_UNKNOWN \
    && (groupVirtualGuid)->objectId == MIG_RTPS_OBJECT_ID_UNKNOWN)

#define PRESPublicationServiceQosPolicy_isDefault(serviceQosPolicy) \
    ((serviceQosPolicy)->kind == PRES_NO_SERVICE_QOS)

#define PRESSubscriptionServiceQosPolicy_isDefault(serviceQosPolicy) \
    (PRESPublicationServiceQosPolicy_isDefault(serviceQosPolicy))

#define PRESPublicationDisableAcks_isDefault(disableAcks) \
    (!(*disableAcks))

#define PRESSubscriptionDisableAcks_isDefault(disableAcks) \
    (PRESPublicationDisableAcks_isDefault(disableAcks))

#define PRESPublicationPublicationName_isDefault(name) \
    ((*name) == NULL)

#define PRESSubscriptionSubscriptionName_isDefault(name) \
    (PRESPublicationPublicationName_isDefault(name))

#define PRESPublicationPublicationRoleName_isDefault(roleName) \
    ((*roleName) == NULL)

#define PRESSubscriptionSubscriptionRoleName_isDefault(roleName) \
    (PRESPublicationPublicationRoleName_isDefault(roleName))

#define PRESPublicationTopicQueryPublicationProperty_isDefault(topicQueryPublicationProperty) \
    (!((topicQueryPublicationProperty)->enable) \
    && (topicQueryPublicationProperty)->numberOfSessions == 0)

#define PRESSubscriptionContentFilterProperty_isEmpty(contentFilterProperty) \
    (PRESSequenceOctet_isEmpty((contentFilterProperty)->propertyData))

#define PRESSubscriptionPropertyChangeEpoch_isDefault(propertyChangeEpoch) \
    ((*propertyChangeEpoch) == PRES_PS_SUBSCRIPTION_PARAMETER_CHANGE_EPOCH_UNKNOWN)

#define PRESSubscriptionExpectsInlineQos_isDefault(expectsInlineQos__) \
    (!(*expectsInlineQos__))



#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* pres_psService_impl_h */
