/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)reda_buffer_impl.h    generated by: makeheader    Sat Mar  9 09:37:39 2024
 *
 *		built from:	buffer_impl.ifc
 */

#ifndef reda_buffer_impl_h
#define reda_buffer_impl_h


#ifdef __cplusplus
    extern "C" {
#endif



#define REDABufferArray_getSize(answer__, array__, arrayCount__) \
{                                                                \
    register int i__ = 0;                                        \
    for (*(answer__) = 0; i__ < (arrayCount__); ++i__) {         \
        *(answer__) += (size_t) (((array__)[i__]).length);       \
    }                                                            \
}

  #define REDABuffer_set(buf, ptr, len) \
  { \
      (buf)->length = (len); \
      (buf)->pointer = (ptr); \
  }

  #define REDABuffer_initializeFromValueType( \
          buf__, \
          valueTypePtr__, \
          valueTypeType__) \
  { \
      (buf__)->length = (RTI_INT32) sizeof(valueTypeType__); \
      (buf__)->pointer = (char *) (valueTypePtr__); \
  }

  #define REDABuffer_initializeFromUInt32(buf__, uint32Ptr__) \
      REDABuffer_initializeFromValueType(buf__, uint32Ptr__, RTI_UINT32)

  #define REDABuffer_reset(buf) REDABuffer_set(buf, NULL, 0)

  #define REDABufferManager_initMacro(me, ptr, len) \
  { \
      (me)->buffer.length = (len); \
      (me)->buffer.pointer = (ptr); \
      (me)->currentPosition = ((me)->buffer.pointer); \
      (me)->errorCount = 0; \
  }

  #ifndef RTI_PRECONDITION_TEST
    #define REDABufferManager_init REDABufferManager_initMacro
  #endif /* !RTI_PRECONDITION_TEST */


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* reda_buffer_impl_h */
