/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)rtixml_parser_impl.h    generated by: makeheader    Sat Mar  9 09:37:50 2024
 *
 *		built from:	parser_impl.ifc
 */

#ifndef rtixml_parser_impl_h
#define rtixml_parser_impl_h


  #include "reda/reda_inlineList.h"
  #include "reda/reda_skiplist.h"
  #include "rtixml/rtixml_extension.h"
  #ifndef rtixml_infrastructure_impl_h
    #include "rtixml/rtixml_infrastructure_impl.h"
  #endif

  #ifdef __cplusplus
      extern "C" {
  #endif



struct RTIXMLDtdParser {
    /*i @brief Init flag */
    int _init;
    /*i @brief Indicates if there is an error parsing the DTD file */
    RTIBool _dtdError;
    struct XML_ParserStruct * _expatParser;
    /*i @brief List that holds the DTD elements */
    struct REDASkiplist _elementList;
    struct REDASkiplistDescription _elementListDesc;
};


struct RTIXMLParser {
    /*i @brief The root object  of the current DOM */
    struct RTIXMLObject * _xmlRoot; /* Must be the first one */

    /*i @brief Init flag */
    int _init;

    /* DTD parsing variables */
    struct RTIXMLDtdParser _dtdParser;
    const char ** _dtdStr;
    int _dtdStrLength;
    struct RTIXMLDtdElementWrapper *_dtdElementWrappers;
    int _dtdElementDepth;
    RTIBool _applyDtd;
    RTIBool _dtdIgnoreUnexpectedElements;

    /*i @brief A list of registered extensions */
    struct REDASkiplistDescription _skipListDesc;
    struct REDASkiplist _extensionList;

    /*i @brief A list of objects being proccesed */
    struct REDAInlineList _processingList;

    struct RTIXMLContext _xmlContext;
    char * _xmlTextBuffer;
    int _xmlTextBufferSize;

    /*i @brief Counter used to assign a name to the anonymous objects */
    int anonymousObjectCount;

    /* XML version */
    char * _version;

    /*i
      @brief Indicates if the object was created from an <include>
    */
    RTIBool included;
    /*i
     */
    struct RTIXMLPropertyList _userEnvironment;

};



  #ifdef __cplusplus
    }	/* extern "C" */
  #endif


#endif /* rtixml_parser_impl_h */
