/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)rtixmlutils_parser.h    generated by: makeheader    Sat Mar  9 10:24:40 2024
 *
 *		built from:	parser.ifc
 */

#ifndef rtixmlutils_parser_h
#define rtixmlutils_parser_h



#include "rtixmlutils/rtixmlutils_dll.h"
#include "rtixmlutils/rtixmlutils_object.h"

#ifdef __cplusplus
    extern "C" {
#endif

extern RTIXMLUTILSDllExport
RTIBool RTIXMLUTILSParser_parseFile(
        struct RTIXMLUTILSObject **root,
        const char *fileName);

extern RTIXMLUTILSDllExport
RTIBool RTIXMLUTILSParser_parseString(
        struct RTIXMLUTILSObject **root,
        const char *xmlString);

extern RTIXMLUTILSDllExport
RTIBool RTIXMLUTILSParser_parseStringArray(
        struct RTIXMLUTILSObject **root,
        const char *xmlStringArray[],
        int xmlStringArrayLength);

extern RTIXMLUTILSDllExport
RTIBool RTIXMLUTILSParser_parseUrlGroup(
        struct RTIXMLUTILSObject **root,
        const char *urlGroup);

extern RTIXMLUTILSDllExport
RTIBool RTIXMLUTILSParser_parseUrlGroupList(
        struct RTIXMLUTILSObject **root,
        const char *urlGroupList);

extern RTIXMLUTILSDllExport
RTIBool RTIXMLUTILSParser_mergeRoot(
        struct RTIXMLUTILSObject *dest,
        struct RTIXMLUTILSObject *from);

extern RTIXMLUTILSDllExport
void RTIXMLUTILSParser_freeDom(struct RTIXMLUTILSObject *element);


#define RTIXMLUTILS_GLOBALS_STRING_RESOURCES_MAX (8)

extern RTIXMLUTILSDllExport
RTIBool RTIXMLUTILSGlobals_initialize(void);

extern RTIXMLUTILSDllExport
void RTIXMLUTILSGlobals_finalize(void);

extern RTIXMLUTILSDllExport
RTIBool RTIXMLUTILSGlobals_registerStringResource(
        const char *stringResourceName,
        const char *stringResource[],
        int stringResourceLength);


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* rtixmlutils_parser_h */
