/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)writer_history_log.h    generated by: makeheader    Sat Mar  9 09:38:34 2024
 *
 *		built from:	log.ifc
 */

#ifndef writer_history_log_h
#define writer_history_log_h



#ifndef log_common_h
  #include "log/log_common.h"
#endif
#ifndef writer_history_dll_h
  #include "writer_history/writer_history_dll.h"
#endif

#ifdef __cplusplus
    extern "C" {
#endif



  /*e \ingroup WriterHistoryLogModule
      \brief Common submodule identifier. For use in log message numbers.
  */
  #define SUBMODULE_NDDS_WRITERHISTORY_COMMON  (0x1000)

  /*e \ingroup WriterHistoryLogModule
      \brief Session submodule identifier. For use in log message numbers.
  */
  #define SUBMODULE_NDDS_WRITERHISTORY_SESSION  (0x2000)

  /*e \ingroup WriterHistoryLogModule
      \brief Memory writer history plugin submodule identifier. For use in log 
      message numbers.
  */
  #define SUBMODULE_NDDS_WRITERHISTORY_MEMORY (0x3000)

  /*e \ingroup WriterHistoryLogModule
      \brief ODBC writer history plugin submodule identifier. For use in log 
      message numbers.
  */
  #define SUBMODULE_NDDS_WRITERHISTORY_ODBC (0x4000)

  /*e \ingroup WriterHistoryLogModule
    \brief Identfier used for enabling log messages in the common submodule.    
  */
  #define NDDS_WRITERHISTORY_SUBMODULE_MASK_COMMON  (0x0001)

  /*e \ingroup WriterHistoryLogModule
    \brief Identfier used for enabling log messages in the session submodule.    
  */
  #define NDDS_WRITERHISTORY_SUBMODULE_MASK_SESSION  (0x0002)

  /*e \ingroup WriterHistoryLogModule
    \brief Memory writer history plugin identifier. Used for enabling log 
    messages in the memory writer history plugin.    
  */
  #define NDDS_WRITERHISTORY_SUBMODULE_MASK_MEMORY  (0x0004)

  /*e \ingroup WriterHistoryLogModule
    \brief ODBC writer history plugin identifier. Used for enabling log 
    messages in the ODBC writer history plugin.    
  */
  #define NDDS_WRITERHISTORY_SUBMODULE_MASK_ODBC  (0x0008)

  /*e \ingroup WriterHistoryLogModule
    \brief ODBC writer history plugin identifier. Used for enabling log 
    messages in the instance state code.
  */
  #define NDDS_WRITERHISTORY_SUBMODULE_MASK_INSTANCE_STATE  (0x0010)

  /*e \ingroup WriterHistoryLogModule
    \brief Convenient way to say "enable logging for all writer history 
    submodules".
  */
  #define NDDS_WRITERHISTORY_SUBMODULE_MASK_ALL RTI_LOG_SUBMODULE_MASK_ALL

extern WRITERHISTORYDllExport
void NDDS_WriterHistory_Log_set_dependency_instrumentation_mask(
        RTILogBitmap verbosity);


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* writer_history_log_h */
