/*
 * (c) Copyright, Real-Time Innovations, 2022.
 * All rights reserved.
 *
 * No duplications, whole or partial, manual or electronic, may be made
 * without express written permission.  Any such copies, or
 * revisions thereof, must display this notice unaltered.
 * This code contains trade secrets of Real-Time Innovations, Inc.
 */

#ifndef HTTP_LOG_HPP
#define HTTP_LOG_HPP

#include "log/log_common.h"
#include "log.peer.h"
#include "apputils/apputils_log.h"

#define APPUTILS_CURRENT_SUBMODULE SUBMODULE_APPUTILS_HTTP

const struct RTILogMessage APPUTILS_LOG_HTTP_EXAMPLE_sss= {
    PRODUCT_WAVEWORKS|MODULE_APPUTILS|SUBMODULE_APPUTILS_HTTP|0, 
    "%s: %s: %s"
};

const struct RTILogMessage APPUTILS_LOG_HTTP_SENT_RESPONSE_us= {
    PRODUCT_WAVEWORKS|MODULE_APPUTILS|SUBMODULE_APPUTILS_HTTP|1, 
    "Sent response %u '%s'\n"
};

constexpr auto msg_client_error_printf = "Client: error at mg_printf";
constexpr auto msg_client_error_url_encode = "Client: error at mg_url_encode";
constexpr auto msg_client_error_get_response_info =
        "Client: error at mg_get_response_info";

constexpr auto msg_server_error_printf = "Server: error at mg_printf";
constexpr auto msg_server_error_read = "Server: error at mg_read";
constexpr auto msg_server_error_send_http_error = "Server: error at mg_send_http_error";
constexpr auto msg_server_error_get_request_info = "Server: error at mg_get_request_info";
constexpr auto msg_server_error_get_header = "Server: error at mg_get_header";

#endif  // HTTP_UTILS_HPP
