/*
 * (c) Copyright, Real-Time Innovations, 2021. All rights reserved.
 *
 * No duplications, whole or partial, manual or electronic, may be made
 * without express written permission.  Any such copies, or
 * revisions thereof, must display this notice unaltered.
 * This code contains trade secrets of Real-Time Innovations, Inc.
 */

#ifndef RTI_WSDDS_WEB_INTEGRATION_SERVICE_IMPL_HPP_
#define RTI_WSDDS_WEB_INTEGRATION_SERVICE_IMPL_HPP_

#include <dds/core/refmacros.hpp>
#include <rti/core/detail/SelfReference.hpp>
#include <rti/webdds/Dll.hpp>

#include <rti/webdds/ServiceProperty.hpp>

#include <memory>

namespace rti { namespace webdds {

namespace  service {
class Service;
}

class WSDDSDllExport WebIntegrationServiceImpl
        : public rti::core::detail::RetainableType<WebIntegrationServiceImpl>
{
public:
    explicit WebIntegrationServiceImpl(ServiceProperty&& property);

    ~WebIntegrationServiceImpl();

    void start();

    void stop();

private:
    std::unique_ptr<rti::webdds::service::Service> impl_;
};

}}

#endif // RTI_WSDDS_WEB_INTEGRATION_SERVICE_IMPL_HPP_
